// FILENAME:	Chiller.cs
//
// AUTHORS:  	Zoltar of the Apocolypse Horsemen 
//		
//		I'd like to thank all those who contributed feedback
//		to make this map a reality. A special thanks to Razor, for
//		without his assistance with the Mission Editor, I would
//		never have pulled off making this map.
//		Enjoy the map!
//				ZOLTAR       
//------------------------------------------------------------------------------

$missionName = "Chiller";

exec("multiplayerStdLib.cs");
exec("DMstdLib.cs");

//------------------------------------------------------------------------------

Pilot Zoltar
{
   id = 29;
   
   skill = 1.0;
   accuracy = 1.0;
   aggressiveness = 0.5;
   activateDist = 2000.0;
   deactivateBuff = 3000.0;
   targetFreq = 4.0;
   trackFreq = 0.1;
   fireFreq = 0.1;
   LOSFreq = 0.4;
   name = "Zoltar";
};

function setDefaultMissionOptions()
{

	$server::TeamPlay = false;
	$server::AllowDeathmatch = true;
	$server::AllowTeamPlay = true;	

// what can the client choose for a team
	$server::AllowTeamRed = false;
	$server::AllowTeamBlue = true;
	$server::AllowTeamYellow = true;
	$server::AllowTeamPurple = false;

// what can the server admin choose for available teams
        $server::disableTeamRed = true;
        $server::disableTeamBlue = false;
        $server::disableTeamYellow = false;
        $server::disableTeamPurple = true;
}
function player::onAdd(%this)
{
       
      say(%this,0, "Welcome to Zoltars Map Chiller !");
	say (%this, 1, "Please read the info tab for game rules");
	say (%this, 2, "Prometheus lurks somewhere on the pyramid!");
	say (%this, 3, "Teleporters are used to reach upper platforms");
	say (%this, 4, "Explore and most of all have fun!");           
}

function onMissionStart()
{
        windSounds();
        iceSounds();
// custom rules for this mission ( teleporter )
   %rules = "<tIDMULT_TDM_GAMETYPE>"   @        
            "<tIDMULT_TDM_MAPNAME>"    @ 
            $missionName               @
            "<tIDMULT_TDM_OBJECTIVES>" @
            "<tIDMULT_TDM_SCORING_1>"  @
            "<tIDMULT_TDM_SCORING_2>"  @
            $killPoints                @
            "<tIDMULT_TDM_SCORING_3>"  @
            "<tIDMULT_TDM_SCORING_4>"  @
            $deathPoints               @
            "<tIDMULT_TDM_SCORING_5>"  @
            "<tIDMULT_TDM_SCORING_6>"  @
            "<tIDMULT_STD_ITEMS>"      @
            "<tIDMULT_STD_TELEPORTER>" @
            "<tIDMULT_STD_HEAL>"       @
            "<tIDMULT_STD_RELOAD>";

   setGameInfo(%rules);        
}

function ZenTransporter::trigger::onContact(%this, %object)
{
	Zen::work(%this, %object, 100000, 100, 0, false);
	setPosition(%object, -1550.96, 1050.56, 125);
}

function ZenTransporter2::trigger::onContact(%this, %object)
{
	Zen::work(%this, %object, 100000, 100, 0, false);
	setPosition(%object, -822.575, -773.172, 1134.02);
}

function ZenTransporter3::trigger::onContact(%this, %object)
{
	Zen::work(%this, %object, 100000, 100, 0, false);
	setPosition(%object, 1240.4, -860.458, 574.199);
}

function ZenTransporter4::trigger::onContact(%this, %object)
{
	Zen::work(%this, %object, 100000, 100, 0, false);
	setPosition(%object, 7089.27, 5010.3, 1400.37);
}

function ZenTransporter5::trigger::onContact(%this, %object)
{
	Zen::work(%this, %object, 100000, 100, 0, false);
	setPosition(%object, 3538.06, 5239.5, 1585.29);
}

function ZenTransporter6::trigger::onContact(%this, %object)
{
	Zen::work(%this, %object, 100000, 100, 0, false);
	setPosition(%object, -3554.26, -4385.8, 154.293);
}

function ZenTransporter7::trigger::onContact(%this, %object)
{
        Zen::work(%this, %object, 100000, 100, 0, false);
	setPosition(%object, -282.437, 203.078, 495.55);
}

function ZenTransporter8::trigger::onContact(%this, %object)
{
        Zen::work(%this, %object, 100000, 100, 0, false);
        setPosition(%object, 235.357, -205.13, 474.962 );
}

function ZenTransporter9::trigger::onContact(%this, %object)
{
        Zen::work(%this, %object, 100000, 100, 0, false);
        setPosition(%object, -41.0561, 189.212, 772.547 );
}

// Healing Pad Functionality
//------------------------------------------------------------------------------
function ZenHeal::trigger::onEnter(%this, %object)
{
   	Zen::onEnter(%this, %object, *IDMULT_CHAT_HEALPAD, true, true);  
}
function ZenHeal::trigger::onContact(%this, %object)
{
   	Zen::work(%this, %object, $healRate, 0, $padWaitTime, true); 
}

// Ammo Pad Functionality
//------------------------------------------------------------------------------
function ZenAmmo::trigger::onEnter(%this, %object)
{
   	Zen::onEnter(%this, %object, *IDMULT_CHAT_AMMOPAD, true, true);  
}

function ZenAmmo::trigger::onContact(%this, %object)
{
   	Zen::work(%this, %object, 0, $ammoRate, $padWaitTime, true); 

//This will enable the doors on the yellow platform to animate
//------------------------------------------------------------------------------
}
function Door1::trigger::onEnter(%this, %vehicleId){
	playAnimSequence(getObjectId("MissionGroup\\Triggers\\Door"), 0, true);
}
function Door1::trigger::onLeave(%this, %vehicleId){
	playAnimSequence(getObjectId("MissionGroup\\Triggers\\Door"), 0, false);
}
function door2::trigger::onEnter(%this, %vehicleId){
	playAnimSequence(getObjectId("MissionGroup\\Triggers\\door2"), 0, true);
}
function door2::trigger::onLeave(%this, %vehicleId){
	playAnimSequence(getObjectId("MissionGroup\\Triggers\\door2"), 0, false);
}
//This script tells the player something when he enters the teleporter
//------------------------------------------------------------------------------
{
function Door1::trigger::onEnter(%this, %vehicleId)
}
	%player = player::vehicleIdToPlayerNum(%vehicleId);
	
			say(%this, 5, "Welcome to Zoltars Battle Arena);
{
