// FILENAME:	DM_City_on_the_Edge.cs
//
// AUTHORS:  	Chupie Doll & Youth in Asia
//------------------------------------------------------------------------------

$missionName = "CvH_DM_City_on_the_Rings";
$server::HudMapViewOffsetX = 2900;
$server::HudMapViewOffsetY = -2400;

exec("multiplayerStdLib.cs");
exec("DMstdLib.cs");
exec("CvH_stdLib.cs");

function setDefaultMissionOptions()
{
	$server::TeamPlay = false;
	$server::AllowDeathmatch = true;
	$server::AllowTeamPlay = true;	

   // what can the client choose for a team
	$server::AllowTeamRed = true;
	$server::AllowTeamBlue = true;
	$server::AllowTeamYellow = false;
	$server::AllowTeamPurple = false;

   // what can the server admin choose for available teams
   $server::disableTeamRed = false;
   $server::disableTeamBlue = false;
   $server::disableTeamYellow = true;
   $server::disableTeamPurple = true;
}
function onMissionLoad(){
   cdAudioCycle("Purge", "Terror", "Watching"); 
}

// Water Tower splash functionality
function structure::onDestroyed(%this, %attackerId){
	// Which water tower was destroyed?
	if(%this == getObjectId("MissionGroup\\BlueBase\\WaterTower1")){
		setShapeVisibility(getObjectId("MissionGroup\\BlueBase\\Splash1"), true);
		playAnimSequence(getObjectId("MissionGroup\\BlueBase\\Splash1"), 0, true);
	}
	else if(%this == getObjectId("MissionGroup\\BlueBase\\WaterTower2")){
		setShapeVisibility(getObjectId("MissionGroup\\BlueBase\\Splash2"), true);
		playAnimSequence(getObjectId("MissionGroup\\BlueBase\\Splash2"), 0, true);
	}
	else if(%this == getObjectId("MissionGroup\\BlueBase\\WaterTower3")){
		setShapeVisibility(getObjectId("MissionGroup\\BlueBase\\Splash3"), true);
		playAnimSequence(getObjectId("MissionGroup\\BlueBase\\Splash3"), 0, true);
	}
}

function onMissionStart()
{
	titanSounds();
}




// ----------------------MOVE CODE---------------------------
// -- Copy this into the new city file, create an object   --
// -- called 'MOVEIT' where you want the new city center.  --
// -- When you scan it, the whole city moves.  --------------
//-----------------------------------------------------------

//$BASEX = -1.46972;
//$BASEY = 191.711;

$BASEX = -20.55;
$BASEY = -9.44;
$BASEZ = -5.63;

function MOVEIT::structure::onScan(%object, %scanner)
{
      %player = playerManager::vehicleIdToPlayerNum(%scanner);

      say(%player, 0, "Attempting Move.", "sfx_had.WAV");

	%x = getPosition(%object,x);
	%y = getPosition(%object,y);
	%z = getTerrainHeight( %x, %y ) + 150;

   	setPosition( %object, %x, %y, %z);

	schedule( "moveCity("@%x@","@%y@");", 1);
	schedule( "moveRedCity("@%x@","@%y@");", 2);
	schedule( "moveBlueCity("@%x@","@%y@");", 3);
	schedule( "moveTriggers("@%x@","@%y@");", 4);
	schedule( "moveGens("@%x@","@%y@");", 5);
	schedule( "moveDPG("@%x@","@%y@","@%player@");", 6);
	schedule( "moveDPG2("@%x@","@%y@");", 7);
	schedule( "moveDPG3("@%x@","@%y@");", 8);
}

function moveCity( %x, %y ) 
{
	%num = 20;
	%ob = getNextObject("MissionGroup\\City", 0);

	for(%i = 0; %i < %num; %i ++ ) {
	   if(!%ob) continue;
	   %oldx = getPosition(%ob,x) - $BASEX;
	   %oldy = getPosition(%ob,y) - $BASEY;
	   %oldz = getPosition(%ob,z) - $BASEZ;

	   %oldrot = getPosition(%ob,rot);
	   %rot = (%oldrot * 57.8);

	   %newx = %x + %oldx;
	   %newy = %y + %oldy;
	   %newz = getTerrainHeight( %newx, %newy ) + %oldz;

   	   setPosition( %ob, %newx, %newy, %newz, %rot);
	   %ob = getNextObject("MissionGroup\\City", %ob);
  	}
}

function moveRedCity( %x, %y ) 
{
	%num = 20;
	%ob = getNextObject("MissionGroup\\redBase", 0);

	for(%i = 0; %i < %num; %i ++ ) {
	   if(!%ob) continue;
	   %oldx = getPosition(%ob,x) - $BASEX;
	   %oldy = getPosition(%ob,y) - $BASEY;
	   %oldz = getPosition(%ob,z) - $BASEZ;

	   %oldrot = getPosition(%ob,rot);
	   %rot = (%oldrot * 57.8);

	   %newx = %x + %oldx;
	   %newy = %y + %oldy;
	   %newz = getTerrainHeight( %newx, %newy ) + %oldz;

   	   setPosition( %ob, %newx, %newy, %newz, %rot);
	   %ob = getNextObject("MissionGroup\\redBase", %ob);
  	}
}

function moveBlueCity( %x, %y ) 
{
	%num = 20;
	%ob = getNextObject("MissionGroup\\blueBase", 0);

	for(%i = 0; %i < %num; %i ++ ) {
	   if(!%ob) continue;
	   %oldx = getPosition(%ob,x) - $BASEX;
	   %oldy = getPosition(%ob,y) - $BASEY;
	   %oldz = getPosition(%ob,z) - $BASEZ;

	   %oldrot = getPosition(%ob,rot);
	   %rot = (%oldrot * 57.8);

	   %newx = %x + %oldx;
	   %newy = %y + %oldy;
	   %newz = getTerrainHeight( %newx, %newy ) + %oldz;

   	   setPosition( %ob, %newx, %newy, %newz, %rot);
	   %ob = getNextObject("MissionGroup\\blueBase", %ob);
  	}
}

function moveTriggers( %x, %y ) 
{
	%num = 20;
	%ob = getNextObject("MissionGroup\\Triggers", 0);

	for(%i = 0; %i < %num; %i ++ ) {
	   if(!%ob) continue;
	   %oldx = getPosition(%ob,x) - $BASEX;
	   %oldy = getPosition(%ob,y) - $BASEY;
	   %oldz = getPosition(%ob,z) - $BASEZ;

	   %oldrot = getPosition(%ob,rot);
	   %rot = (%oldrot * 57.8);

	   %newx = %x + %oldx;
	   %newy = %y + %oldy;
	   %newz = getTerrainHeight( %newx, %newy ) + %oldz;

   	   setPosition( %ob, %newx, %newy, %newz, %rot);
	   %ob = getNextObject("MissionGroup\\Triggers", %ob);
  	}
}

function moveGens( %x, %y ) 
{
	%num = 20;
	%ob = getNextObject("MissionGroup\\PowerGenerators", 0);

	for(%i = 0; %i < %num; %i ++ ) {
	   if(!%ob) continue;
	   %oldx = getPosition(%ob,x) - $BASEX;
	   %oldy = getPosition(%ob,y) - $BASEY;
	   %oldz = getPosition(%ob,z) - $BASEZ;

	   %oldrot = getPosition(%ob,rot);
	   %rot = (%oldrot * 57.8);

	   %newx = %x + %oldx;
	   %newy = %y + %oldy;
	   %newz = getTerrainHeight( %newx, %newy ) + %oldz;

   	   setPosition( %ob, %newx, %newy, %newz, %rot);
	   %ob = getNextObject("MissionGroup\\PowerGenerators", %ob);
  	}
}

function moveDPG( %x, %y, %p) 
{
	%num = 20;
	%ob = getNextObject("MissionGroup\\DropPointGroup", 0);

	for(%i = 0; %i < %num; %i ++ ) {
	   if(!%ob) continue;
	   %oldx = getPosition(%ob,x) - $BASEX;
	   %oldy = getPosition(%ob,y) - $BASEY;
	   %oldz = getPosition(%ob,z) - $BASEZ;

	   %oldrot = getPosition(%ob,rot);
	   %rot = (%oldrot * 57.8);

	   %newx = %x + %oldx;
	   %newy = %y + %oldy;
	   %newz = getTerrainHeight( %newx, %newy ) + %oldz;

   	   setPosition( %ob, %newx, %newy, %newz, %rot);
	   %ob = getNextObject("MissionGroup\\DropPointGroup", %ob);
  	}
}

function moveDPG2( %x, %y ) 
{
	%num = 20;
	%ob = getNextObject("MissionGroup\\DropPointGroup2", 0);

	for(%i = 0; %i < %num; %i ++ ) {
	   if(!%ob) continue;
	   %oldx = getPosition(%ob,x) - $BASEX;
	   %oldy = getPosition(%ob,y) - $BASEY;
	   %oldz = getPosition(%ob,z) - $BASEZ;

	   %oldrot = getPosition(%ob,rot);
	   %rot = (%oldrot * 57.8);

	   %newx = %x + %oldx;
	   %newy = %y + %oldy;
	   %newz = getTerrainHeight( %newx, %newy ) + %oldz;

   	   setPosition( %ob, %newx, %newy, %newz, %rot);
	   %ob = getNextObject("MissionGroup\\DropPointGroup2", %ob);
  	}
}

function moveDPG3( %x, %y ) 
{
	%num = 20;
	%ob = getNextObject("MissionGroup\\DropPointGroup3", 0);

	for(%i = 0; %i < %num; %i ++ ) {
	   if(!%ob) continue;
	   %oldx = getPosition(%ob,x) - $BASEX;
	   %oldy = getPosition(%ob,y) - $BASEY;
	   %oldz = getPosition(%ob,z) - $BASEZ;

	   %oldrot = getPosition(%ob,rot);
	   %rot = (%oldrot * 57.8);

	   %newx = %x + %oldx;
	   %newy = %y + %oldy;
	   %newz = getTerrainHeight( %newx, %newy ) + %oldz;

   	   setPosition( %ob, %newx, %newy, %newz, %rot);
	   %ob = getNextObject("MissionGroup\\DropPointGroup3", %ob);
  	}
}

