exec("multiplayerStdLib.cs");
exec("DF_RemoteLib.cs");

$irq=0;
$movex=0;
$movey=0;
$posx=-15;
$posy=589;
$time=-1;
$redgoals=0;
$bluegoals=0;

function setDefaultMissionItems()
{
	allowComponent(all,True);
	noCheapWeapons();
}

function setDefaultMissionOptions()
{
   $server::AllowTeamRed      = true;
   $server::AllowTeamBlue     = true;
   $server::AllowTeamYellow   = false;
   $server::AllowTeamPurple   = false;

   $server::TeamPlay          = true;
   $server::AllowDeathmatch   = false;
   $server::AllowTeamPlay     = true;	

   $server::disableTeamRed    = false;
   $server::disableTeamBlue   = false;
   $server::disableTeamYellow = true;
   $server::disableTeamPurple = true;
}

function onMissionStart()
{
		$ball = getObjectId("MissionGroup/Stuff/Ball");
		$kick = getObjectId("MissionGroup/Stuff/KICK");
		$redgoalx = getPosition(getObjectId("MissionGroup/Stuff/BlueGoal"),x);
		$bluegoalx = getPosition(getObjectId("MissionGroup/Stuff/RedGoal"),x);
		// r=-63 b=32 getPosition(getObjectId("MissionGroup/Stuff/BlueGoal"),x);
}

function vehicle::onAdd(%this)
{
	if ($irq!=1)
	{
		$irq=1;
		schedule("interrupt();",5);
	}
	if ($time>0)
	{
		%player=playerManager::vehicleIdToPlayerNum(%vehicleId);
		setHudTimer(getCurrentTime()-$time,down,"Game time left:",1,%player);
	}
}

function onMissionLoad()
{
   cdAudioCycle("Purge"); 
   %ausgabe1 = "Welcome to the Soccer!\n\n"
             @ $copyright;
   setGameInfo(%ausgabe1);
}

initscoreboard();

function abs(%zahl)
{
	if (%zahl < 0) %zahl=-%zahl;
	return %zahl;
}

function ballHit(%attacked,%attacker,%how)
{
	if ($time<0)
	{
		$time=getCurrentTime()+300;
		say(0,1,"Game started!");
		setHudTimer($time-getCurrentTime(),down,"Game time left:",1);
	}
	if (%attacked != %attacker)
	{
		%dx=getPosition(%attacker,x) - getPosition(%attacked,x);
		%dy=getPosition(%attacker,y) - getPosition(%attacked,y);
		%faktor = 0;
		if (abs(%dx)<1)
		{
			if (%dx<0)
			{
				%dx=1;
			}
			else
			{
				%dx=-1;
			}
		}
		if (abs(%dy)<1)
		{
			if (%dy<0)
			{
				%dy=1;
			}
			else
			{
				%dy=-1;
			}
		}		
		if (abs(%dx) > abs(%dy))
		{
			%faktor=abs(%dx);
		}
		else
		{
			%faktor=abs(%dy);
		}
		if (%how == "kick")
		{
			%faktor=%faktor*2;
		}
		$movex=$movex-%dx/%faktor/6;
		$movey=$movey-%dy/%faktor/6;
	}
}

function ball::structure::onAttacked(%attacked,%attacker)
{
	ballHit(%attacked,%attacker,"shot");
}

function ball::structure::onScan(%scanned,%scanner)
{
	reloadObject(%scanner,10000);
}

function KICK::trigger::onContact(%attacked,%attacker)
{
	ballHit($ball,%attacker,"kick");
}

function interrupt()
{
	if (getCurrentTime()>$time && $time>0)
	{
		$irq=0;
		schedule("gameended();",2);	
	}
	if (($posx<-832 && $movex<0) || ($posx>832 && $movex>0))
	{
		$movex=-$movex;
	}
	if ($posy<-736 && $movey<0)
	{
		if (abs($bluegoalx-$posx)<=20)
		{
			say(0,1,"Goal!!!","alarm2.wav");
			schedule("goal(1);",0.5);
		}
		$movey=-$movey;
	}
	if ($posy>1920 && $movey>0)
	{
		if (abs($redgoalx-$posx)<=20)
		{
			say(0,1,"Goal!!!","alarm2.wav");
			schedule("goal(2);",0.5);
		}
		$movey=-$movey;
	}
	$posx = $posx + $movex;
	$posy = $posy + $movey;
	setposition($ball,$posx,$posy,95);
	setposition($kick,$posx,$posy,90);
	$movex=$movex*0.995;
	$movey=$movey*0.995;
	if ($irq==1)
	{
		schedule("interrupt();",0.03);
	}
}

// ----------------------------

function goal(%team)
{
	$movex=0;
	$movey=0;
	$posx=-15;
	$posy=589;
	setposition($ball,$posx,$posy,95);
	if (%team==2)
	{
		%text="Blue";
		$bluegoals++;
	}
	else
	{
		%text="Red";
		$redgoals++;
	}
	messagebox(0,%text @ " team scored! Red:Blue=" @ $redgoals @ ":" @ $bluegoals);
}

// ---------------------------

function gameended()
{
	messagebox(0,"Time's up!");
	%text="DRAW! muahaha!";
	if ($bluegoals>$redgoals)
	{
		%text="Blue team wins!";
	}
	if ($redgoals>$bluegoals)
	{
		%text="Red team wins!";
	}
	messagebox(0,%text);
	$movex=0;
	$movey=0;
	$posx=-15;
	$posy=589;
	$time=-1;
	$redgoals=0;
	$bluegoals=0;
	flushconsolescheduler();
	schedule("missionendconditionmet();",3);	
}