// FILENAME:	DM_GhostTown.cs
// AUTHORS:  	[OF] Pincushion (pgarpincushion@geocities.com)
//              http://www.geocities.com/SoHo/Nook/9351/maps/index.html
// DATE:        13 September 2002
// NOTES:       Uses the stock terrain DM_City_on_the_Edge.ted.vol

$missionName = "DM_GhostTown";

exec("multiplayerStdLib.cs");
exec("DMstdLib.cs");

function setDefaultMissionOptions() {
	$server::TeamPlay = false;
	$server::AllowDeathmatch = true;
	$server::AllowTeamPlay = true;	
	
	$server::AllowTeamRed = true;
	$server::AllowTeamBlue = true;
	$server::AllowTeamYellow = true;
	$server::AllowTeamPurple = true;
}

function onMissionStart() {
	windSounds();
}

function onMissionLoad(){
	$server::HudMapViewOffsetX = getPosition("MissionGroup/Origin",x);
	$server::HudMapViewOffsetY = getPosition("MissionGroup/Origin",y);
	cdAudioCycle("Mechsoul", "Newtech", "Yougot"); 

	// change "(0)" to "(1)" to disable teleport gimmick
	if (0) {
		for (%i=0;%i<9;%i++) {
			%o = "MissionGroup/Town/D"@%i;
			deleteObject(%o);
		}
	}
}

// a modified version of randomTransport() from multiplayerStdLib.cs
function TeleportVehicleToObject(%vid,%obj,%dz,%radius)
{
	//echo("TeleportVehicleToObject to "@%obj);
	%x = getPosition(%obj,x);
	%y = getPosition(%obj,y);
	%z = getTerrainHeight(%x,%y) + %dz;
	%x = randomInt(%x-%radius,%x+%radius);
	%y = randomInt(%y-%radius,%y+%radius);

	%playerNum = playerManager::vehicleIdToPlayerNum(%vid);
 
	// play a sound at both locations
	playSound(0, IDSFX_TELEPORTER, IDPRF_NEAR, %vid);
	playSound(0, IDSFX_TELEPORTER, IDPRF_NEAR, %x, %y, %z);
   
	if(%playerNum != 0) {
		fadeEvent(%playerNum, out, 1.0, 1.0, 1.0, 1.0);
		schedule(strcat("fadeEvent(",%playerNum,",in,1.0,1.0,1.0,1.0);"), 1.2);
	}
	schedule(strcat("setPosition(",%vid,",",%x,",",%y,",",%z,");"), 1.0);   
}

function structure::onScan(%ee,%er) {
	for (%i=0;%i<9;%i++) {
		%o = "MissionGroup/Town/D"@%i;
		if (%ee == getObjectId(%o)) {
			TeleportVehicleToObject(%er,%o,90,5);
			return;
		}
	}
}
