//======================================================================
//  	CM_RedWhirlwind.cs
//  	Author:		ACrisp
//   	Based on the Starsiege Storyline by Blake Hutchins and Dynamix
//======================================================================

$actionStarted = false;
$attackStarted = false;


Pilot Naoko
{
   id = 28;
   name = "Naoko Miki";
   skill = 0.8;
   accuracy = 0.8;
   aggressiveness = 0.8;
   activateDist = 300.0;
   deactivateBuff = 300.0;
   targetFreq = 5.0;
   trackFreq = 1.0;
   fireFreq = 1.0;
   LOSFreq = 0.1;
   orderFreq = 4.0;
};

Pilot Socrates
{
   id = 29;
   name = "Socrates";
   skill = 0.6;
   accuracy = 0.6;
   aggressiveness = 0.7;
   activateDist = 250.0;
   deactivateBuff = 300.0;
   targetFreq = 4.0;
   trackFreq = 1.0;
   fireFreq = 0.8;
   LOSFreq = 0.1;
   orderFreq = 3.0;
};

Pilot SunTzu
{
   id = 30;
   name = "Sun Tzu";
   skill = 0.6;
   accuracy = 0.6;
   aggressiveness = 0.8;
   activateDist = 250.0;
   deactivateBuff = 250.0;
   targetFreq = 4.0;
   trackFreq = 1.0;
   fireFreq = 0.8;
   LOSFreq = 0.1;
   orderFreq = 3.0;
};

Pilot Aristotle
{
   id = 31;
   name = "Aristotle";
   skill = 0.7;
   accuracy = 0.5;
   aggressiveness = 0.9;
   activateDist = 200.0;
   deactivateBuff = 200.0;
   targetFreq = 4.0;
   trackFreq = 0.2;
   fireFreq = 0.5;
   LOSFreq = 0.1;
   orderFreq = 3.0;
};

Pilot Icehawk
{
   id = 32;
   name = "Caanon Weathers";
   skill = 0.6;
   accuracy = 0.8;
   aggressiveness = 1.0;
   activateDist = 250.0;
   deactivateBuff = 200.0;
   targetFreq = 2.0;
   trackFreq = 0.4;
   fireFreq = 0.2;
   LOSFreq = 0.2;
   orderFreq = 2.0;
};

Pilot Rebel
{
   id = 33;
   name = "Rebel";
   skill = 0.4;
   accuracy = 0.4;
   aggressiveness = 1.0;
   activateDist = 550.0;
   deactivateBuff = 300.0;
   targetFreq = 4.0;
   trackFreq = 2.0;
   fireFreq = 0.5;
   LOSFreq = 0.5;
   orderFreq = 2.0;
};

Pilot RebVeteran
{
   id = 34;
   name = "Veteran Rebel";
   skill = 0.5;
   accuracy = 0.5;
   aggressiveness = 0.8;
   activateDist = 700.0;
   deactivateBuff = 300.0;
   targetFreq = 3.0;
   trackFreq = 1.0;
   fireFreq = 1.0;
   LOSFreq = 0.2;
   orderFreq = 1.5;
};

//-----------------------------------------------------------------------------
function setDefaultMissionOptions()
{

	$server::TeamPlay = true;
	$server::AllowDeathmatch = false;
	$server::AllowTeamPlay = true;	

   // what can the client choose for a team
	$server::AllowTeamRed = true;
	$server::AllowTeamBlue = false;
	$server::AllowTeamYellow = true;
	$server::AllowTeamPurple = false;

   // what can the server admin choose for available teams
   $server::disableTeamRed = false;
   $server::disableTeamBlue = true;
   $server::disableTeamYellow = false;
   $server::disableTeamPurple = true;

}

//-----------------------------------------------------------------------------
function onMissionStart()
{
   cdAudioCycle("Purge", "Cyberntx", "Cloudburst");

   init();   
}

//-----------------------------------------------------------------------------
function onMissionLoad()
{

    $textMsg = "Liberate Carter Flats from the rebellion.\n\n"@
      "Complete Objectives:"@
      "\n1) Secure Carter Flats."@
      "\n2) Destroy any rebels encountered."@
      "\n3) Protect Caanon Weathers.\n"@
   "Respawning is not allowed. Destroying an enemy heals your vehicle and"@
   " reloads your weapons. Team Damage is on, watch your fire.";

   %history = 
"\n\nDate: 2829.3851. Attention, Knights!  We've been given the order to drop onto " @
"Mars.  Our first objective is to liberate the town of Carter Flats, the last area " @
"to fall to the rebels.\n\n" @
"You are being assigned to Katana Sword, under command by Knight-Captain Naoko Miki."@
"  Your DZ is located north of Carter Flats.  Once you are on the surface, proceed to " @
"the town and sweep it of any rebel presence.  Wolf Pack intelligence suggests the " @
"rebels may attempt an ambush, so stay sharp.  Drop commences in five minutes.";

   setGameInfo ($textMsg @ %history);

}

//-----------------------------------------------------------------------------
function player::onAdd(%this)                                                                                                                        
{


say ( %this, 0, $Version @"\n"@ $textMsg );
say ( %this, 0,  "Check the game info tab for more details");
say ( %this, 0,  "<F5>Objective: Secure Carter Flats from the rebels");

}

//-----------------------------------------------------------------------------
function vehicle::onAdd(%this)                                                                                                                        
{


// see if it is a player, if not exit
   %player = playerManager::vehicleIdToPlayerNum(%this);

   if (%player == 0) 
      return;


// messagebox (%player, "Proceed to Nav Alpha and liberate the town there.");

say (%player, "Proceed to Nav Alpha and liberate Carter Flats.");
say (%player, "Check the game info tab for game details and objectives");

                                                                                   
   if (getTeam (%this) != *IDSTR_TEAM_YELLOW)
    {
     setTeam(%this, *IDSTR_TEAM_YELLOW);
     redrop(%this);
    }

 schedule( "setEnemyNavPoint(" @ %this @ ");", 3 );

 if ( $actionStarted == true )
   {
    if ( %player.state == "tked" )  
        {
   	%player.state = "";
        }
      else
        {
        //schedule ("healObject(" @ %this @ ", -50000);", 3);
        //Say(%player,0,"Sorry, you can't join until the next game.");
       }
   }

}

function init()
{

   $objective = false;

   $actionStarted = false;
   $attackStarted = false;
   $ambushDone = false;
   $rebLost = false;

  $navAlpha   = "MissionGroup/navMarkers/NavAlpha";
  $navBravo   = "MissionGroup/navMarkers/NavBravo";

  newObject( "Knights", SimGroup );
  addToSet( "MissionGroup", "Knights" );

  $knights = "MissionGroup/Knights";

  newObject( "AmbushGroup", SimGroup );
  addToSet( "MissionGroup", "AmbushGroup" );

  $rebels1 = "MissionGroup/AmbushGroup";

  newObject( "olyPatrol", SimGroup );
  addToSet( "MissionGroup", "olyPatrol" );

  $olyPatrol = "MissionGroup/olyPatrol";

  newObject( "defenseGroup", SimGroup );
  addToSet( "MissionGroup", "defenseGroup" );

  $rebels2 = "MissionGroup/defenseGroup";

  $knightPath = "MissionGroup/KnightPath";
  $OlyPath = "MissionGroup/OlyPath";
  
                                       
  schedule ( "createKnights();", 2);
  schedule ( "createOlys();", 5);

   MPcheckBoundary( leave, getObjectID ($navBravo) , 250, onLeaveNavBravoWarning, 1 );
   MPcheckBoundary( leave, getObjectID ($navBravo) , 400, onLeaveNavBravo, 5 );

}

//-----------------------------------------------------------------------------
function setEnemyNavPoint( %this )
{
  setNavMarker( $navAlpha, true, %this );
}


//-----------------------------------------------------------------------------
function vehicle::onDestroyed(%this, %who)
{

// player dESTROYED 
   if( %this == $Caanon )
   {
     setDominantCamera($Caanon, %who);
     say (0,0,"<f5>\nCaanon Weathers was killed.\n");
     schedule ("missionFailed();", 5 );
   }

   if( %this == $Naoko )
   {
     setDominantCamera($Naoko, %who);
     say (0,0,"<f5>\nNaoko Miki was killed.\n");
     schedule ("missionFailed();", 5 );
   }

   if( %this == $Socrates )
   {
     setDominantCamera($Socrates, %who);
     say (0,0,"<f5>\nSocrates was killed.\n");
     schedule ("missionFailed();", 5 );
   }

   // give the death messages...
   %message = getFancyDeathMessage(getHUDName(%this), getHUDName(%who));
   if(%message != "")
   {
      say( 0, 0, %message);
   }


  if ( $actionStarted == true ) checkForPlayersDead();

// see if it is a player
   %player = playerManager::vehicleIdToPlayerNum(%this);
   if(%player == 0) 
   {
    schedule( "deleteObject(" @ %this @ ");", 5 );
    checkRedropSquad();

   }

// heal and reload player or friendly AI
   if (getTeam(%who) == *IDSTR_TEAM_YELLOW)
    {
      healObject( %who, 10000);
      reloadObject( %who, 10000);
    }

   if ((%this != %who) &&
      (getTeam(%this) == getTeam(%who)) &&
      (getTeam(%this) == *IDSTR_TEAM_YELLOW))
    {
     %killerName = getHudName ( %who );
     %name = getHudName ( %this );

// Team kill, take action
     say(0,0,%killerName@" is being kicked for team-killing "@%name@".");
     say(%who, %who, "", "rules_violated.wav");
     %player = playerManager::vehicleIdToPlayerNum ( %who );
     kick ( %player, *IDMULT_CHAT_TEAM_KILL_KICK );

// allow TKed player to return
     say(%this, %this, "A teammate killed you. You may respawn.");
     %this.state = "tked";
    }
}


//-----------------------------------------------------------------------------
function pickPlayer ()
{

// 100 so we can be assured of getting a live player
   for (%p = 0; %p < 100; %p++)
     {
      %player = playerManager::getPlayerNum( randomInt( 0, playerManager::getPlayerCount() - 1 ) );

      %playerVeh = playerManager::playerNumToVehicleId( %player);

      if (( %playerVeh != "" ) &&
          (isGroupDestroyed (%playerVeh) == false))
       {
         return %playerVeh;
       }
     }
  return 0;
}

//-----------------------------------------------------------------------------
function checkForPlayersDead()
{
  %allDead = true;

   %playerCount = playerManager::getPlayerCount();

   for (%p = 0; %p < %playerCount; %p++)
     {
      %player = playerManager::getPlayerNum( %p );

      %playerVeh = playerManager::playerNumToVehicleId( %player);

      if (( %playerVeh != "" ) &&
          (isGroupDestroyed (%playerVeh) == False))
       {

         %allDead = False;
       }
     }

  if ( %allDead == true ) schedule ("missionFailed();", 3);

}


function createKnights()
{
  // Naoko
  %herc = cloneVehicle (getObjectID("MissionGroup/KnightModels/herc1"));
  setTeam (%herc, *IDSTR_TEAM_YELLOW);
  setPilotId (%herc, 28);
  addToSet( "MissionGroup/Knights", %herc ); 
  %p = getObjectID("MissionGroup\\KnightSpawnPoints\\NaokoSpawn");
  %x = getPosition ( %p, x);
  %y = getPosition ( %p, y);
  placeObject(%herc, %x, %y, 180);
  $Naoko = %herc;

  // Socrates
  %herc = cloneVehicle (getObjectID("MissionGroup/KnightModels/herc2"));
  setTeam (%herc, *IDSTR_TEAM_YELLOW);
  setPilotId (%herc, 29);
  addToSet( "MissionGroup/Knights", %herc ); 
  %x = getPosition ( getObjectID("MissionGroup/KnightSpawnPoints/SocratesSpawn"), x);
  %y = getPosition ( getObjectID("MissionGroup/KnightSpawnPoints/SocratesSpawn"), y);
  placeObject(%herc, %x, %y, 180);
  $Socrates = %herc;

  // Aristotle
  %herc = NewObject ("Aristotle", Tank, 15);
  setTeam (%herc, *IDSTR_TEAM_YELLOW);
  setPilotId (%herc, 31);
  addToSet( "MissionGroup/Knights", %herc ); 
  %x = getPosition ( getObjectID("MissionGroup/KnightSpawnPoints/AristotleSpawn"), x);
  %y = getPosition ( getObjectID("MissionGroup/KnightSpawnPoints/AristotleSpawn"), y);
  placeObject(%herc, %x, %y, 180);
  $Aristotle = %herc;

  // Sun Tzu
  %herc = NewObject ("SunTzu", Herc, 10);
  setTeam (%herc, *IDSTR_TEAM_YELLOW);
  setPilotId (%herc, 30);
  addToSet( "MissionGroup/Knights", %herc ); 
  %x = getPosition ( getObjectID("MissionGroup/KnightSpawnPoints/SunTzuSpawn"), x);
  %y = getPosition ( getObjectID("MissionGroup/KnightSpawnPoints/SunTzuSpawn"), y);
  placeObject(%herc, %x, %y, 180);
  $Sun = %herc;

  // Caanon
  %herc = NewObject ("Caanon", Herc, 42);
  setTeam (%herc, *IDSTR_TEAM_YELLOW);
  setPilotId (%herc, 32);
  addToSet( "MissionGroup/Knights", %herc ); 
  %x = getPosition ( getObjectID("MissionGroup/KnightSpawnPoints/IcehawkSpawn"), x);
  %y = getPosition ( getObjectID("MissionGroup/KnightSpawnPoints/IcehawkSpawn"), y);
  placeObject(%herc, %x, %y, 180);
  $Caanon = %herc;

}

//-----------------------------------------------------------------------------
function MPcheckBoundary( %dir, %obj2, %distance, %callback, %time )
{
// This is a modification of the campaign function "CheckBoundary"
//
// %dir  - enter or leave
// %obj2 - any object you want the players distance compared to
//         must be an ID (use getObjectid) and not a string ("MissionGroup/RedHerc/h1")
// %distance - if entering, they'd be within this range to run the function
//             if leaving, they'd be outside this range to run the function
// %callback - name of the function to run
// %time - when to reschedule the next check

  %jobRun = false;

   %playerCount = playerManager::getPlayerCount();

   for(%i=0; %i < %playerCount ; %i++)
     {
     %player = playerManager::getPlayerNum( %i );

     %obj1= playerManager::playerNumToVehicleId( %player);

   %var = getDistance( %obj1, %obj2 );

    if (%var != "0")
     {
     if( %dir == "enter" || %dir == "Enter" )
       {
        if( %var <= %distance )
          {
          if ( %jobRun == false )
            {
              %func = %callback @ "(" @ %obj1 @ ");";
              schedule( %func, 0 );
              %jobRun = true;
            }
          }
       }
    else if( %dir == "leave" || %dir == "Leave" )
      {
       if( %var >= %distance )
         {
          if ( %jobRun == false )
            {
              %func = %callback @ "();";
              schedule( %func, 0 );
              %jobRun = true;
            }
         }
      }
    }
  } // end for loop

  if  (%jobRun != true )
   {
   schedule( "MPcheckBoundary( "
             @ %dir @ ", "
             @ %obj2 @ ", "
             @ %distance @ ", "
             @ %callback @ ", "
             @ %time @ ");",
             %time );

   }

}

//-----------------------------------------------------------------------------
function countLivePlayers ()
{

  %count = 0;

   %playerCount = playerManager::getPlayerCount();

   for (%p = 0; %p < %playerCount; %p++)
     {
      %player = playerManager::getPlayerNum( %p );

      %playerVeh = playerManager::playerNumToVehicleId( %player);

      if (( %playerVeh != "" ) &&
          (isGroupDestroyed (%playerVeh) == False))
       {
         %count++;
       }
     }
  return %count;

}

//-----------------------------------------------------------------------------
function placeObject (%object, %x, %y, %rot)
{

  if ( %rot == "" ) %rot = 0;

  %z = getTerrainHeight(%x, %y);
  setPosition (%object, %x, %y, %z + 2, %rot);

}

//-----------------------------------------------------------------------------
function missionFailed()
{
  flushConsoleScheduler();
  messageBox(0, "Mission Failed" );
  deleteObject($knights);
  deleteObject($rebels1);
  deleteObject($rebels2);
  deleteObject($olyPatrol);
  deleteObject($knightPath);
  deleteObject($OlyPath);

  // $MissionCycling::Stage0 = "c_martian_recon";
  // $server::Mission = $MissionCycling::Stage0; 
  missionEndConditionMet();
  // schedule("missionEndConditionMet();", 10);
  
}

//-----------------------------------------------------------------------------
function winCondition()
{
  flushConsoleScheduler();
  %howmany = 0;

  %text = "\nCarter Flats liberated: ";
  if ( $objective == true )
    {
     %howmany++;
     %text = %text @ "Successful";
    }
   else
    {
     %text = %text @ "Failed";
    }
  
  if ( %howmany == 1 ) %text = %text @ "\nExcellent work team.";

  messageBox(0, "Mission Completed, " @ %howmany @ " of 1 objectives completed. "@ %text );
  deleteObject($knights);
  deleteObject($rebels1);
  deleteObject($rebels2);
  deleteObject($olyPatrol);
  deleteObject($knightPath);
  deleteObject($OlyPath);

  // $MissionCycling::Stage0 = "c_martian_recon";
  // $server::Mission = $MissionCycling::Stage0;  
  missionEndConditionMet();
  // schedule("missionEndConditionMet();", 10);
}

//-----------------------------------------------------------------------------
function onLeaveNavBravo()
{
   say (0,0, "ICEHAWK: CC to all Swords, advance on Carter Flats. Status is red and hot. Anything moves, vape it.");
   order ($knights, speed, medium);
   order ($knights, guard, $knightPath);
   schedule ("ambush();", 5);
   $actionStarted = true;
   onArriveNavAlpha();
}

//-----------------------------------------------------------------------------
function onLeaveNavBravoWarning()
{
   say (0,0, "<f5>ATTENTION: you are leaving the drop zone.  By doing so, you will start the mission.  Remember: NO RESPAWNS!");
}

//-----------------------------------------------------------------------------
function onArriveNavAlpha()
{

 %obj1 = getObjectID ( $navAlpha );
 %howMany = countLivePlayers ();

 %howManyAreClose = 0;

   %playerCount = playerManager::getPlayerCount();

   for (%p = 0; %p < %playerCount; %p++)
     {
      %player = playerManager::getPlayerNum( %p );

      %playerVeh = playerManager::playerNumToVehicleId( %player);

      if (( %playerVeh != "" ) &&
          (isGroupDestroyed (%playerVeh) == false))
       {

          %var = getDistance( %obj1, %playerVeh );
          if ( %var < 300 ) %howManyAreClose++;
       }
     }

  if (( %howManyAreClose == %howMany ) && ($objective == TRUE))
    {
     schedule ( "winCondition();", 5);
    }
   else
    {
      schedule ("onArriveNavAlpha();", 10 );
    }
}

//-----------------------------------------------------------------------------
function ambush()
{
   %howmany = countLivePlayers();
   %howmany = %howmany + randomInt(4,6);

   for (%i = 0; %i <= %howmany; %i++ )
     {
      %r = randomInt (1,4);
      if (%r == 1)
       {
         %herc = cloneVehicle(getObjectID("MissionGroup/RebelModels/tank1"));
       }
      else if (%r == 2)
       {
         %herc = cloneVehicle(getObjectID("MissionGroup/RebelModels/herc1"));
       }
      else
       {
         %herc = cloneVehicle(getObjectID("MissionGroup/RebelModels/herc2"));
       }


      setTeam( %herc, *IDSTR_TEAM_RED);
      setPilotID( %herc, randomInt(33, 34) );
      addToSet( "MissionGroup/AmbushGroup", %herc);
      %xref = getPosition ( getObjectID($navBravo), x );
      %yref = getPosition ( getObjectID($navBravo), y );
      %deltaX = randomInt(100,1800);
      %deltay = 1900 - %deltaX;
      %direction = randomInt(1,2);
      if (%direction == 1)
       {
         %x = %xref + %deltaX;
       }
      else
       {
         %x = %xref - %deltaX;
       }
      %y = %yref - %deltaY;
      placeObject(%herc, %x, %y);
      order (%herc, cloak, true);
     }
    schedule ( "order ($rebels1, attack, $knights);", 5);
}

//-----------------------------------------------------------------------------
function createRebelPerimeter()
{
   %howmany = countLivePlayers();
   %howmany = int(%howmany * 1.4) + 4;
   %xref = getPosition ( getObjectID($navAlpha), x );
   %yref = getPosition ( getObjectID($navAlpha), y );

   for (%i = 0; %i <= %howmany; %i++ )
     {
      %name = "Rebel" @ %i;
      %r = randomInt (1,4);
      if (%r == 1)
       {
         %herc = NewObject( %name, Herc, 33 );
       }
      else if (%r == 2)
       {
         %herc = NewObject( %name, Tank, 31 );
       }
      else
       {
         %herc = cloneVehicle(getObjectID("MissionGroup/RebelModels/herc2"));
       }
      setTeam( %herc, *IDSTR_TEAM_RED);
      setPilotID( %herc, randomInt(33, 34) );
      addToSet( "MissionGroup/defenseGroup", %herc);
      %deltaX = randomInt(100,1000);
      %deltay = 1100 - int(%deltaX/2);
      %direction = randomInt(1,2);
      if (%direction == 1)
       {
         %x = %xref + %deltaX;
       }
      else
       {
         %x = %xref - %deltaX;
       }
      %y = %yref + %deltaY;
      placeObject(%herc, %x, %y);
     }
}


function createOlys()
{
    %x = getPosition( getObjectID( "MissionGroup/OlyPath/marker1" ), x);
    %y = getPosition( getObjectID( "MissionGroup/OlyPath/marker1" ), y);
    %herc = NewObject( "olympian1", Herc, 33 );
    setTeam ( %herc, *IDSTR_TEAM_RED );
    setPilotID( %herc, 34 );
    addToSet ( "MissionGroup/olyPatrol", %herc );
    placeObject ( %herc, %x, %y );
    order (%herc, speed, medium);
    order (%herc, guard, $OlyPath);

    %x = getPosition( getObjectID( "MissionGroup/OlyPath/marker4" ), x);
    %y = getPosition( getObjectID( "MissionGroup/OlyPath/marker4" ), y);
    %herc = NewObject( "olympian2", Herc, 33 );
    setTeam ( %herc, *IDSTR_TEAM_RED );
    setPilotID( %herc, 34 );
    addToSet ( "MissionGroup/olyPatrol", %herc );
    placeObject ( %herc, %x, %y );
    order (%herc, speed, medium);
    order (%herc, guard, $OlyPath);
}

function checkRedropSquad()
{
    if ($attackStarted == FALSE) return;
    if ((isGroupDestroyed($rebels1) == TRUE) && ($ambushDone == FALSE))
     {
       $ambushDone = TRUE;
       schedule ( "createRebelPerimeter();", 5);
     }
    if (isGroupDestroyed($olyPatrol) == TRUE)
     {
       if ($rebLost == FALSE)
        {
          $rebLost = TRUE;
          say (0,0, "REBEL TRANSMISSION: All crews fall back!" );
          order ($rebels2, guard, getObjectID("MissionGroup/RebelModels"));
          $objective = true;
        }
     }
}

//----------------------------------------------------------------
function vehicle::onAttacked(%attacked, %attacker)
{
   if ($attackStarted == false) $attackStarted = TRUE;

//-----------------Backfire stuff---------------------------------
//----------------------------------------------------------------

   if ((%attacked != %attacker) &&
      (getTeam(%attacked) == getTeam(%attacker)) &&
      (getTeam(%attacked) == *IDSTR_TEAM_YELLOW))
    {
//     %killerName = getHudName ( %attacker );

// Take action against killer
//     say(0,0,%killerName@" is probably Vegeta & got blown up.");
//     say(%attacker, %attacker, "", "rules_violated.wav");
//     healobject ( %attacker, -600 );
//     healobject ( %attacked, 900 );

//     %x = getPosition(%attacker,x);
//     %y = getPosition(%attacker,y);
//     %z = getPosition(%attacker,z);
//     %z = %z + 10.0;
//     setPosition(%attacker,%x,%y,%z);
    }
//----------------------------------------------------------------
//----------------------------------------------------------------

}















