// FILENAME:	Escort_Duty.cs
// Version 1.08f - delete variables
// AUTHORS:  	ACrisp (Components by Dolf Kooz)
//------------------------------------------------------------------------------

console::enable(true);


Pilot PatrolPilot1
{
   id = 28;
   
   skill = 0.3;
   accuracy = 0.3;
   aggressiveness = 0.9;
   activateDist = 450.0;
   deactivateBuff = 300.0;
   targetFreq = 3.5;
   trackFreq = 0.2;
   fireFreq = 2.0;
   LOSFreq = 0.2;
   orderFreq = 4.0;
};

Pilot PatrolPilot2
{
   id = 29;
   
   skill = 0.4;
   accuracy = 0.4;
   aggressiveness = 0.9;
   activateDist = 450.0;
   deactivateBuff = 300.0;
   targetFreq = 3.0;
   trackFreq = 0.3;
   fireFreq = 2.0;
   LOSFreq = 0.2;
   orderFreq = 4.0;
};

Pilot PatrolPilot3
{
   id = 30;
   
   skill = 0.5;
   accuracy = 0.5;
   aggressiveness = 0.9;
   activateDist = 450.0;
   deactivateBuff = 300.0;
   targetFreq = 2.5;
   trackFreq = 0.1;
   fireFreq = 2.0;
   LOSFreq = 0.2;
   orderFreq = 4.0;
};

Pilot PatrolPilot4
{
   id = 31;
   
   skill = 0.6;
   accuracy = 0.6;
   aggressiveness = 0.9;
   activateDist = 450.0;
   deactivateBuff = 300.0;
   targetFreq = 1.5;
   trackFreq = 0.1;
   fireFreq = 2.0;
   LOSFreq = 0.2;
   orderFreq = 4.0;
};

$missionName = "Escort_Duty";

//exec("multiplayerStdLib.cs");
//exec("DMstdLib.cs");

//------------ADD AS A TEST---------------
function setDefaultMissionOptions()
{
	$server::TeamPlay = true;
	$server::AllowDeathmatch = False;
	$server::AllowTeamPlay = true;	

   // what can the client choose for a team
	$server::AllowTeamRed = true;
	$server::AllowTeamBlue = False;
	$server::AllowTeamYellow = true;
	$server::AllowTeamPurple = False;

   // what can the server admin choose for available teams
   $server::disableTeamRed = False;
   $server::disableTeamBlue = true;
   $server::disableTeamYellow = False;
   $server::disableTeamPurple = true;

}
//---------ADD AS A TEST-------------------

function onMissionStart()
{
        cdAudioCycle("ss4", "Cloudburst", "ss3"); 
	europaSounds();
        init();
}

function onMissionLoad()
{
   
    
   $textMsg ="Mission Credits:  A. Crisp  \n\n"@   
      "Escort our supply convoy to the rendevous point.\nYou are authorized to use tech 3 items.\n"@
      "Complete Objectives:"@
      "\n1) Proceed to our base at nav Alpha."@
      "\n2) Escort the convoy to nav Bravo.\n"@
   "Respawning is not allowed. Scanning the repair truck heals your vehicle and "@
   " reloads your weapons. Team Damage is on, watch your fire.";

   %history = 
"\n\nDate: 2829.1660. Welcome to Europa, troops.  I'm Commander Malcolm Richter, and I will be your tactical commander during your stay here.\n\n" @
"Listen carefully.  A pirate group known as the Jovian Dark Knights have been attacking supply and resource convoys at various spots across Europa.  "@
"I'm assigning your squad to Venga Linea, where a supply convoy is ferrying hardware to a special project there.  "@
"We'll set you down near our supply base, where the convoy is due to refuel before travelling to the rendevous "@
"point.  Orbital Recon will maintain a watch for pirate activity, so keep your comm lines open." @
"\n\nGet your Hercs ready, troops.  The dropship leaves in ten minutes.";

   setGameInfo ($textMsg @ %history);

}

//-----------------------------------------------------------------------------
function init()
{

$minAIPilotID = 28;
$maxAIPilotID = 31;

   $actionStarted = false;
   $attackStarted = false;
   $spares = 3;

   $objective = false;

   $navAlpha   = "MissionGroup/navPoints/navAlpha";
   $navBravo   = "MissionGroup/navPoints/navBravo";
   $navCharlie = "MissionGroup/navPoints/navCharlie";

   $convoyPath = "MissionGroup/ConvoyPath";
   $impPath    = "MissionGroup/ImpPath";
   $imps       = "MissionGroup/ImpPatrol";

   $point1     = getObjectID("MissionGroup/ConvoyPath/marker1");
   $point2     = getObjectID("MissionGroup/ConvoyPath/marker3");
   $truckSpawn = getObjectID("MissionGroup/Stuff/truckSpawn");

   $tank       = getObjectID("MissionGroup/Models/Tank1");
   $emanc      = getObjectID("MissionGroup/Models/Herc1");

   newObject ("Pirates1", SimGroup);
   addToSet ("MissionGroup", "Pirates1");
   newObject ("Pirates2", SimGroup);
   addToSet ("MissionGroup", "Pirates2");
   newObject ("Convoy", SimGroup);
   addToSet ("MissionGroup", "Convoy");

   $Pirates1 = "MissionGroup/Pirates1";
   $Pirates2 = "MissionGroup/Pirates2";
   $Convoy   = "MissionGroup/Convoy";

   createConvoy();
   createTruck();

//   MPcheckBoundary( leave, getObjectID ($navCharlie) , 250, onLeaveNavCharlieWarning, 1 );
//   MPcheckBoundary( leave, getObjectID ($navCharlie) , 450, onLeaveNavCharlie, 1 );
   onLeaveNavCharlie();
   
}

//-----------------------------------------------------------------------------
function player::onAdd(%this)                                                                                                                        
{


say ( %this, 0, $Version @"\n"@ $textMsg );
say ( %this, 0,  "Check the game info tab for more details");
say ( %this, 0,  "<F5>Objective: Proceed to our base at Nav Alpha");

}

//-----------------------------------------------------------------------------
function vehicle::onAdd(%this)                                                                                                                        
{


// see if it is a player, if not exit
   %player = playerManager::vehicleIdToPlayerNum(%this);

   if (%player == 0) 
      return;


// messagebox (%player, "Proceed to Nav Alpha and destroy the Brid supply base.");

say (%player, "Escort our supply convoy and defend it from attacks.");
say (%player, "Check the game info tab for game details and objectives");

                                                                                   
   if (getTeam (%this) != *IDSTR_TEAM_YELLOW)
    {
     setTeam(%this, *IDSTR_TEAM_YELLOW);
     redrop(%this);
    }

 schedule( "setEnemyNavPoint(" @ %this @ ");", 3 );

 if ( $actionStarted == true )
   {
    if ( %player.state == "tked" )  
        {
   	%player.state = "";
        }
//      else
//        {
//        schedule ("healObject(" @ %this @ ", -50000);", 3);
//        Say(%player,0,"Sorry, you can't join until the next game.");
//       }
   }

}

//-----------------------------------------------------------------------------
function vehicle::onDestroyed(%this, %who)
{

// player dESTROYED 

   // give the death messages...
   %message = getFancyDeathMessage(getHUDName(%this), getHUDName(%who));
   if(%message != "")
   {
      say( 0, 0, %message);
   }


  if ( $actionStarted == true ) checkForPlayersDead();

// see if it is a player
   %player = playerManager::vehicleIdToPlayerNum(%this);
   if(%player == 0) 
   {
    schedule( "deleteObject(" @ %this @ ");", 1 );
    checkRedropSquad();

   }

   if (%this == $repair)
    {
      redropTruck();
    }

   if ((%this != %who) &&
      (getTeam(%this) == getTeam(%who)) &&
      (getTeam(%this) == *IDSTR_TEAM_YELLOW))
    {
     %killerName = getHudName ( %who );
     %name = getHudName ( %this );

// Team kill, take action
     say(0,0,%killerName@" is being kicked for team-killing "@%name@".");
     say(%who, %who, "", "rules_violated.wav");
     %player = playerManager::vehicleIdToPlayerNum ( %who );
     kick ( %player, *IDMULT_CHAT_TEAM_KILL_KICK );

// allow TKed player to return
     say(%this, %this, "A teammate killed you. You may respawn.");
     %this.state = "tked";
    }
}

function vehicle::onScan(%scanned, %scanner)
{
   %who = playerManager::vehicleIdToPlayerNum(%scanner);

   if ( %scanned == $repair )
    {
         // heals and reloads the scanner's vehicle
         
         order (%scanned, guard, %scanner);

         say (%who, 0, "REPAIR TRUCK: Acknowledged, sir.  Commencing repair and reload.");
         healObject (%scanner, 5000);
         reloadObject (%scanner, 5000);

    }
}


//-----------------------------------------------------------------------------
function pickPlayer ()
{

// 100 so we can be assured of getting a live player
   for (%p = 0; %p < 100; %p++)
     {
      %player = playerManager::getPlayerNum( randomInt( 0, playerManager::getPlayerCount() - 1 ) );

      %playerVeh = playerManager::playerNumToVehicleId( %player);

      if (( %playerVeh != "" ) &&
          (isGroupDestroyed (%playerVeh) == false))
       {
         return %playerVeh;
       }
     }
  return 0;
}

//-----------------------------------------------------------------------------
function onLeaveNavCharlie ()
{

say (0,0, "ORBITAL RECON: Your callsign for this mission will be Kodiak.  Recon sats are green and report no hostile activity.");
order($Convoy, guard, $convoyPath);
order($imps, guard, $Convoy);
checkWaypoint1();

}

//-----------------------------------------------------------------------------
function onLeaveNavCharlieWarning ()
{
   say (0,0, "<f5>You are leaving the drop zone. By doing so you will start the mission.");
}

//-----------------------------------------------------------------------------
function setEnemyNavPoint( %this )
{
  setNavMarker( $navAlpha, true, %this );
}

function createConvoy()
{
   %x = 2300;
   %y = 4800;

   for (%i = 0; %i < 2; %i++)
    {
      %name = "ammo"@ %i;
      %herc = newObject( %name, Tank, 62 );
      setTeam( %herc, *IDSTR_TEAM_YELLOW);
      addToSet ($Convoy, %herc);
      placeObject(%herc, %x, %y, 180);
      if (%i == 0)
       {
         $truck1 = %herc;
       }
      if (%i == 1)
       {
         $truck2 = %herc;
       }

      %y = %y + 25;
    }

   for (%i = 0; %i < 2; %i++)
    {
      %name = "mino"@ %i;
      %herc = newObject( %name, Tank, 65 );
      setTeam( %herc, *IDSTR_TEAM_YELLOW);
      addToSet ($Convoy, %herc);
      placeObject(%herc, %x, %y, 180);
      if (%i == 0)
       {
         $truck3 = %herc;
       }
      if (%i == 1)
       {
         $truck4 = %herc;
       }


      %y = %y + 25;
    }

}

function createTruck()
{
   %x = getPosition( $truckSpawn, x );
   %y = getPosition( $truckSpawn, y );

   %herc = newObject( "Repair", Tank, 71);
   setTeam ( %herc, *IDSTR_TEAM_YELLOW );

   addToSet( "MissionGroup/Stuff", %herc );
   placeObject ( %herc, %x, %y, 90 );
   $repair = %herc;
}

function checkWaypoint1()
{
   %var = getDistance( $truck1, $point1 );

   if ( %var < 100 )
    {
      say (0,0, "DRACO PATROL: TAC-COM, this is Draco.  We've reached the Venga Linea Supply Base and are passing the baton.  Kodiak Patrol, the convoy's in your hands now.  Good luck out there.");
      $actionStarted = true;
      setNavBravoON();
      order( $imps, clear );
      schedule ( "order( $imps, guard, $impPath );", 2 );
      schedule ( "startAttack();", 35);
      checkConvoy();
    }
   else 
    {
      schedule ( "checkWaypoint1();", 5);
    }

}

function waypoint::trigger::onEnter( %this, %object )
{
    %safe = false;
    if (%object == $truck1)
     {
       %safe = true;
     } 
    else if (%object == $truck2)
     {
       %safe = true;
     }
    else if (%object == $truck3)
     {
       %safe = true;
     }
    else if (%object == $truck4)
     {
       %safe = true;
     }
    if (%safe == true )
     {
       order( $Convoy, clear );
       say (0,0, "CONVOY: TAC-COM, we've reached the designated rendevous point.  You can contact the Tarazedi when ready.");
       schedule( "say( 0, 0, \"GEN_OC01.wav\" );", 2 );
       $objective1 = true;
       $attackStarted = false;
       onArriveNavBravo();
     }
    
}

function checkConvoy()
{
    if ( isGroupDestroyed( $Convoy ) == true )
     {
       say (0,0, "<f5>Convoy destroyed.", "Mission_fail.wav");
       schedule ("missionFailed();", 5);
     }
    else
     {
       schedule( "checkConvoy();", 5 );
     }

}

function startAttack()
{
   say (0,0, "ORBITAL RECON: Kodiak Patrol, we are detecting hostile units in the area.  Be on the alert for attacks.");
   $attackStarted = true;
   createPirates1();
   schedule ( "moreTrouble();", 120);
}

function moreTrouble()
{
   say (0,0, "ORBITAL RECON: Kodiak Patrol, we are detecting heavy hercs on an intercept vector.  They are headed straight for the convoy!");
   createPirates2();
}

//-----------------------------------------------------------------------------
function MPcheckBoundary( %dir, %obj2, %distance, %callback, %time )
{
// This is a modification of the campaign function "CheckBoundary"
//
// %dir  - enter or leave
// %obj2 - any object you want the players distance compared to
//         must be an ID (use getObjectid) and not a string ("MissionGroup/RedHerc/h1")
// %distance - if entering, they'd be within this range to run the function
//             if leaving, they'd be outside this range to run the function
// %callback - name of the function to run
// %time - when to reschedule the next check

  %jobRun = false;

   %playerCount = playerManager::getPlayerCount();

   for(%i=0; %i < %playerCount ; %i++)
     {
     %player = playerManager::getPlayerNum( %i );

     %obj1= playerManager::playerNumToVehicleId( %player);

   %var = getDistance( %obj1, %obj2 );

    if (%var != "0")
     {
     if( %dir == "enter" || %dir == "Enter" )
       {
        if( %var <= %distance )
          {
          if ( %jobRun == false )
            {
              %func = %callback @ "(" @ %obj1 @ ");";
              schedule( %func, 0 );
              %jobRun = true;
            }
          }
       }
    else if( %dir == "leave" || %dir == "Leave" )
      {
       if( %var >= %distance )
         {
          if ( %jobRun == false )
            {
              %func = %callback @ "();";
              schedule( %func, 0 );
              %jobRun = true;
            }
         }
      }
    }
  } // end for loop

  if  (%jobRun != true )
   {
   schedule( "MPcheckBoundary( "
             @ %dir @ ", "
             @ %obj2 @ ", "
             @ %distance @ ", "
             @ %callback @ ", "
             @ %time @ ");",
             %time );

   }

}


//-----------------------------------------------------------------------------
function pickPlayer ()
{

// 100 so we can be assured of getting a live player
   for (%p = 0; %p < 100; %p++)
     {
      %player = playerManager::getPlayerNum( randomInt( 0, playerManager::getPlayerCount() - 1 ) );

      %playerVeh = playerManager::playerNumToVehicleId( %player);

      if (( %playerVeh != "" ) &&
          (isGroupDestroyed (%playerVeh) == False))
       {
         return %playerVeh;
       }
     }
  return 0;
}

//-----------------------------------------------------------------------------
function countLivePlayers ()
{

  %count = 0;

   %playerCount = playerManager::getPlayerCount();

   for (%p = 0; %p < %playerCount; %p++)
     {
      %player = playerManager::getPlayerNum( %p );

      %playerVeh = playerManager::playerNumToVehicleId( %player);

      if (( %playerVeh != "" ) &&
          (isGroupDestroyed (%playerVeh) == False))
       {
         %count++;
       }
     }
  return %count;

}

//-----------------------------------------------------------------------------
function placeObject (%object, %x, %y, %rot)
{

  if ( %rot == "" ) %rot = 0;

  %z = getTerrainHeight(%x, %y);
  setPosition (%object, %x, %y, %z + 2, %rot);

}

//-----------------------------------------------------------------------------
function setNavBravoON()
{
   %playerCount = playerManager::getPlayerCount();

   for (%p = 0; %p < %playerCount; %p++)
     {
      %player = playerManager::getPlayerNum( %p );

      %playerVeh = playerManager::playerNumToVehicleId( %player);

      setNavMarker( $navBravo, true, %playerVeh  );
     }
}

//-----------------------------------------------------------------------------
function checkForPlayersDead()
{
  %allDead = true;

   %playerCount = playerManager::getPlayerCount();

   for (%p = 0; %p < %playerCount; %p++)
     {
      %player = playerManager::getPlayerNum( %p );

      %playerVeh = playerManager::playerNumToVehicleId( %player);

      if (( %playerVeh != "" ) &&
          (isGroupDestroyed (%playerVeh) == False))
       {

         %allDead = False;
       }
     }

  if ( %allDead == true ) schedule ("missionFailed();", 3);

}

//-----------------------------------------------------------------------------
function missionFailed()
{
  flushConsoleScheduler();
  messageBox(0, "Mission Failed" );

  deleteObject("MissionGroup");
  deleteObject("MissionCleanup");
  deleteVariables($objective1);
  deleteVariables($objective2);
  deleteVariables($objective);
  deleteVariables($navAlpha);
  deleteVariables($navBravo);
  deleteVariables($navCharlie);
  deleteVariables($convoyPath);
  deleteVariables($impPath);
  deleteVariables($imps);
  deleteVariables($point1);
  deleteVariables($point2);
  deleteVariables($tank);
  deleteVariables($emanc);
  deleteVariables($Pirates1);
  deleteVariables($Pirates2);
  deleteVariables($Convoy);
  deleteVariables($truck1);
  deleteVariables($truck2);
  deleteVariables($truck3);
  deleteVariables($truck4);
  deleteVariables($truckSpawn);
  deleteVariables($truckspawn1);
  deleteVariables($repair);
  deleteVariables($spares);

  // $MissionCycling::Stage0 = "c_fear_no_evil";
  // $server::Mission = $MissionCycling::Stage0;
  missionEndConditionMet();
  // schedule("missionEndConditionMet();", 10);
  
}

//-----------------------------------------------------------------------------
function winCondition()
{
  flushConsoleScheduler();
  %howmany = 0;

  %text = "\nConvoy escorted safely: ";
  if ( $objective1 == true )
    {
     %howmany++;
     %text = %text @ "Successful";
    }
   else
    {
     %text = %text @ "Failed";
    }
  %text = %text @ "\nPirate forces destroyed: ";
  if ( $objective2 == true )
    {
     %howmany++;
     %text = %text @ "Successful";
    }
   else
    {
     %text = %text @ "Failed";
    }
  if ( %howmany == 2 ) %text = %text @ "\nExcellent work team.";

  messageBox(0, "Mission Completed, " @ %howmany @ " of 2 objectives completed. "@ %text );

  deleteObject("MissionGroup");
  deleteObject("MissionCleanup");
  deleteVariables($objective1);
  deleteVariables($objective2);
  deleteVariables($objective);
  deleteVariables($navAlpha);
  deleteVariables($navBravo);
  deleteVariables($navCharlie);
  deleteVariables($convoyPath);
  deleteVariables($impPath);
  deleteVariables($imps);
  deleteVariables($point1);
  deleteVariables($point2);
  deleteVariables($tank);
  deleteVariables($emanc);
  deleteVariables($Pirates1);
  deleteVariables($Pirates2);
  deleteVariables($Convoy);
  deleteVariables($truck1);
  deleteVariables($truck2);
  deleteVariables($truck3);
  deleteVariables($truck4);
  deleteVariables($truckSpawn);
  deleteVariables($truckspawn1);
  deleteVariables($repair);
  deleteVariables($spares);

  // $MissionCycling::Stage0 = "c_fear_no_evil";
  // $server::Mission = $MissionCycling::Stage0;
  missionEndConditionMet();
  // schedule("missionEndConditionMet();", 10);
}

//-----------------------------------------------------------------------------

function createPirates1()
{
  %howMany = countLivePlayers ();

  if ( %howMany > 4 ) %howMany = 4;

  %target = pickPlayer ();

  %x1 = getPosition( %target, x );
  %y = getPosition( %target, y );

  %j = randomInt (1, 2);
  if (%j == 1)
   {
     %x = %x1 + 1200;
   }
  else 
   {
     %x = %x1 - 1200;
   } 

  for ( %i = 0; %i < %howMany ; %i++ )
    {

//if ( %i > 10 ) break;

     %name = "Pirate"@ %i;
     %r = randomInt (1, 4);

   if (%r == 1)
    {
     %herc = NewObject( %name, Herc, 52);
    }
   if (%r == 2)
    {
     %herc = cloneVehicle ($tank);
    }
   if (%r == 3)
    {
      %herc = cloneVehicle ($emanc);
    }

     setTeam (%herc, *IDSTR_TEAM_RED);
     %pilotID = randomInt ( $minAIPilotID, $maxAIPilotID );
     setPilotId (%herc, %pilotID);

     addToSet( $Pirates1, %herc ); 

     placeObject(%herc, %x, %y, 180);

     %y = %y + 10;

    } // end for loop

    %j = randomInt (1, 3);
    
    if (%j == 2)
     {
       order ($Pirates1, attack, $Convoy);
     }
    else
     {
       order ($Pirates1, attack, %target);
     }

}

function createPirates2()
{

  %x = 2600;
  %y = -600;

  for ( %i = 0; %i < 2 ; %i++ )
    {

//if ( %i > 10 ) break;

     %name = "Pirate"@ %i;
     %herc = NewObject( %name, Herc, 50);

     setTeam (%herc, *IDSTR_TEAM_RED);
     %pilotID = randomInt ( $minAIPilotID, $maxAIPilotID );
     setPilotId (%herc, %pilotID);

     addToSet( $Pirates2, %herc ); 

     placeObject(%herc, %x, %y, 90);

     %y = %y + 10;

    } // end for loop

   order ($Pirates2, attack, $Convoy);
   
}

//-----------------------------------------------------------------------------
function checkRedropSquad()
{
   if ((isGroupDestroyed($Pirates1) == true) && ($attackStarted == true))
    {
      createPirates1();
    }
}

//-----------------------------------------------------------------------------
function onArriveNavBravo()
{

 %obj1 = getObjectID ( $navBravo );
 %howMany = countLivePlayers ();

 %howManyAreClose = 0;

   %playerCount = playerManager::getPlayerCount();

   for (%p = 0; %p < %playerCount; %p++)
     {
      %player = playerManager::getPlayerNum( %p );

      %playerVeh = playerManager::playerNumToVehicleId( %player);

      if (( %playerVeh != "" ) &&
          (isGroupDestroyed (%playerVeh) == false))
       {
          %var = getDistance( %obj1, %playerVeh );
          if ( %var < 300 ) %howManyAreClose++;
       }
     }

  if (( %howManyAreClose == %howMany ) && ( isGroupDestroyed($Pirates1) == true) && ( isGroupDestroyed($Pirates2) == true ))
    {
       say (0,0, "TAC-COM: Orbital Recon reports no more pirate activity, and we are reading a Tarazedi patrol approaching your position as arranged.  Good work, Kodiak.");
       schedule( "say( 0, 0, \"GEN_OC01.wav\" );", 2 );
       $objective2 = true;
       schedule ( "winCondition();", 5);
     
    }
   else
    {
      schedule ("onArriveNavBravo();", 10 );
    }

}

function redropTruck()
{
   if ($spares > 0)
    {
      say (0,0, "<f5>Repair truck destroyed.  A spare truck is departing from base.");
      %x = getPosition( $truckspawn1, x );
      %y = getPosition( $truckspawn1, y );

      %herc = newObject( "Repair", Tank, 71);
      setTeam ( %herc, *IDSTR_TEAM_YELLOW );

      addToSet( "MissionGroup/Stuff", %herc );
      placeObject ( %herc, %x, %y, 180 );
      $repair = %herc;  
      $spares--;

      %target = pickPlayer();
      order ($repair, guard, %target);

    }
}