// FILENAME:	Pirate_Hunt.cs
//
// AUTHORS:  	ACrisp (Components by Dolf Kooz)
// Version 1.08f - delete variables stuff
//------------------------------------------------------------------------------

console::enable(true);


Pilot Pilot1
{
   id = 28;
   
   skill = 0.3;
   accuracy = 0.3;
   aggressiveness = 0.9;
   activateDist = 450.0;
   deactivateBuff = 300.0;
   targetFreq = 3.5;
   trackFreq = 0.2;
   fireFreq = 2.0;
   LOSFreq = 0.2;
   orderFreq = 4.0;
};

Pilot Pilot2
{
   id = 29;
   
   skill = 0.4;
   accuracy = 0.4;
   aggressiveness = 0.9;
   activateDist = 450.0;
   deactivateBuff = 300.0;
   targetFreq = 3.0;
   trackFreq = 0.3;
   fireFreq = 2.0;
   LOSFreq = 0.2;
   orderFreq = 4.0;
};

Pilot Pilot3
{
   id = 30;
   
   skill = 0.5;
   accuracy = 0.5;
   aggressiveness = 0.9;
   activateDist = 450.0;
   deactivateBuff = 300.0;
   targetFreq = 2.5;
   trackFreq = 0.1;
   fireFreq = 2.0;
   LOSFreq = 0.2;
   orderFreq = 4.0;
};

Pilot Pilot4
{
   id = 31;
   
   skill = 0.6;
   accuracy = 0.6;
   aggressiveness = 0.9;
   activateDist = 450.0;
   deactivateBuff = 300.0;
   targetFreq = 1.5;
   trackFreq = 0.1;
   fireFreq = 2.0;
   LOSFreq = 0.2;
   orderFreq = 4.0;
};

$missionName = "Pirate_Hunt";

$server::TeamDamage = true;

//exec("multiplayerStdLib.cs");
//exec("DMstdLib.cs");

//------------ADD AS A TEST---------------
function setDefaultMissionOptions()
{
	$server::TeamPlay = true;
	$server::AllowDeathmatch = False;
	$server::AllowTeamPlay = true;	

   // what can the client choose for a team
	$server::AllowTeamRed = true;
	$server::AllowTeamBlue = False;
	$server::AllowTeamYellow = true;
	$server::AllowTeamPurple = False;

   // what can the server admin choose for available teams
   $server::disableTeamRed = False;
   $server::disableTeamBlue = true;
   $server::disableTeamYellow = False;
   $server::disableTeamPurple = true;

}
//---------ADD AS A TEST-------------------

function onMissionStart()
{
        cdAudioCycle("Watching", "Purge", "Gnash"); 
	europaSounds();
        setHostile (*IDSTR_TEAM_YELLOW, *IDSTR_TEAM_RED);
        setHostile (*IDSTR_TEAM_PURPLE, *IDSTR_TEAM_RED);
        init();
}

function onMissionLoad()
{
   
    $textMsg = "Mission Credits:  A. Crisp,  "@    
      "Locate and secure a pirate supply base.\n\n"@
      "Complete Objectives:"@
      "\n1) Follow all waypoints until you find the base."@
      "\n2) Subdue all defenses at the base."@
      "\n3) Download files from the base's central computer.\n"@
   "Respawning is not allowed. Scanning the repair truck heals your vehicle and"@
   " reloads your weapons. Team Damage is on, watch your fire.";

   %history = 
"\n\nDate: 2829.2846. The Dark Knights have stepped up their attacks.  The situation has gotten serious enough that the Emperor has dispatched a Sword of Knights to stabilize the situation.\n\n" @
"The recent attacks have given us a new opportunity, however.  Intel has analyzed the attack pattern and has found what they believe to be the primary supply base for the pirates, located somewhere in Moytura Regio.  Your mission is to pinpoint and secure this base.\n\n"@
"We'll set you down near the most recent attack site.  Search the site for survivors and any evidence.  When you find the base, be sure to download any files from the computer nets.  We need to know who is supplying these terrorists.";

   setGameInfo ($textMsg @ %history);

}

//-----------------------------------------------------------------------------
function init()
{

$minAIPilotID = 28;
$maxAIPilotID = 31;

   $actionStarted = false;
   $attackStarted = false;

   $objective1 = false;
   $objective2 = false;
   $linkActive = false;
   $filesTransferred = 0;
   $guardsDead = false;
   $turretsDead = false;
   $complaint = false;
   $spares = 2;

   $navAlpha   = "MissionGroup/navPoints/navAlpha";
   $navBravo   = "MissionGroup/navPoints/navBravo";
   $navCharlie = "MissionGroup/navPoints/navCharlie";
   $navTransport = "MissionGroup/navPoints/navTransport";

   $VulturePath = "MissionGroup/VulturePath";

   newObject ( "Drones", SimGroup );
   addToSet ( "MissionGroup", "Drones" );
   newObject ( "Flyers", SimGroup );
   addToSet ( "MissionGroup", "Flyers" );
   newObject ( "Rebs", SimGroup );
   addToSet ( "MissionGroup", "Rebs" );
   newObject ( "Vulture", SimGroup );
   addToSet ( "MissionGroup", "Vulture" );
   newObject ( "Pirates1", SimGroup );
   addToSet ( "MissionGroup", "Pirates1" );
   newObject ( "Pirates2", SimGroup );
   addToSet ( "MissionGroup", "Pirates2" );
   newObject ( "Pirates3", SimGroup );
   addToSet ( "MissionGroup", "Pirates3" );

   $drones = "MissionGroup/Drones";
   $Flyers = "MissionGroup/Flyers";
   $Rebs   = "MissionGroup/Rebs";
   $Vulture = "MissionGroup/Vulture";
   $Guards1 = "MissionGroup/Pirates1";
   $Guards2 = "MissionGroup/Pirates2";
   $Pirates = "MissionGroup/Pirates3";
   $turrets = "MissionGroup/PirateTurrets";

   $Fusion     = getObjectID( "MissionGroup/PirateBase/Fusion");
   $CommCenter = getObjectID ( "MissionGroup/PirateBase/CommCenter");

   createDrones();
   createFlyers();
   createRebel();
   

   MPcheckBoundary( leave, getObjectID ($navTransport) , 250, onLeaveNavTransportWarning, 1 );
   MPcheckBoundary( leave, getObjectID ($navTransport) , 450, onLeaveNavTransport, 1 );
   
     
}

//-----------------------------------------------------------------------------
function player::onAdd(%this)                                                                                                                        
{


say ( %this, 0, $Version @"\n"@ $textMsg );
say ( %this, 0,  "Check the game info tab for more details");

}

//-----------------------------------------------------------------------------
function vehicle::onAdd(%this)                                                                                                                        
{


// see if it is a player, if not exit
   %player = playerManager::vehicleIdToPlayerNum(%this);

   if (%player == 0) 
      return;


// messagebox (%player, "Proceed to Nav Alpha and destroy the Brid supply base.");

say (%player, "Find and secure the Dark Knights supply base.");
say (%player, "Check the game info tab for game details and objectives");

                                                                                   
   if (getTeam (%this) != *IDSTR_TEAM_YELLOW)
    {
     setTeam(%this, *IDSTR_TEAM_YELLOW);
     redrop(%this);
    }

 schedule( "setEnemyNavPoint(" @ %this @ ");", 3 );

 if ( $actionStarted == true )
   {
    if ( %player.state == "tked" )  
        {
   	%player.state = "";
        }
      else
        {
        // schedule ("healObject(" @ %this @ ", -50000);", 3);
        // Say(%player,0,"Sorry, you can't join until the next game.");
       }
   }

}

//-----------------------------------------------------------------------------
function vehicle::onDestroyed(%this, %who)
{

// player dESTROYED 

   // give the death messages...
   %message = getFancyDeathMessage(getHUDName(%this), getHUDName(%who));
   if(%message != "")
   {
      say( 0, 0, %message);
   }


  if ( $actionStarted == true ) checkForPlayersDead();

// see if it is a player
   %player = playerManager::vehicleIdToPlayerNum(%this);
   if(%player == 0) 
   {
    schedule( "deleteObject(" @ %this @ ");", 1 );
    checkRedropSquad();

   }
   
   if (%this == $truck)
    {
      redropTruck();
    }

   if ((%this != %who) &&
      (getTeam(%this) == getTeam(%who)) &&
      (getTeam(%this) == *IDSTR_TEAM_YELLOW))
    {
     %killerName = getHudName ( %who );
     %name = getHudName ( %this );

// Team kill, take action
     say(0,0,%killerName@" is being kicked for team-killing "@%name@".");
     say(%who, %who, "", "rules_violated.wav");
     %player = playerManager::vehicleIdToPlayerNum ( %who );
     kick ( %player, *IDMULT_CHAT_TEAM_KILL_KICK );

// allow TKed player to return
     say(%this, %this, "A teammate killed you. You may respawn.");
     %this.state = "tked";
    }
}

function vehicle::onScan(%scanned, %scanner)
{
   %who = playerManager::vehicleIdToPlayerNum(%scanner);

   if ( %scanned == $truck )
    {
         // heals and reloads the scanner's vehicle
         
         order (%scanned, guard, %scanner);

         say (%who, 0, "REPAIR TRUCK: Acknowledged, sir.  Commencing repair and reload.");
         healObject (%scanner, 5000);
         reloadObject (%scanner, 5000);

    }

}

function structure::onDestroyed(%destroyed, %destroyer)
{
   if (( %destroyed == $CommCenter ) && ($objective2 == false))
    {
      say (0,0, "<F5>Base Computer destroyed.  Mission Failed", "Mission_fail.wav");
      schedule ( "missionFailed();", 5);
    }
   if (( %destroyed == $Fusion ) && ( $objective2 == false ))
    {
      say (0,0, "<F5>DANGER: Fusion Generator compromised!  Nuclear Detonation in progress!", "Mission_fail.wav");
      schedule ( "damageArea( $Fusion, 0, 0, 0, 1500, 1500000);", 5);
      schedule ( "missionFailed();", 8);
    }

   // checks to see if all base defenses are down


}

//-----------------------------------------------------------------------------
function datalink::trigger::onEnter( %this, %object )
{
   %player = playerManager::vehicleIdToPlayerNum(%object);
   if ( %player != 0 )
    {
      if ( $linkActive == false )
       {
         $linkActive = true;
         say(0,0, "<F5>Data-link Engaged.", "dlink_engaged.wav");
       }  
    }
   
}

function datalink::trigger::onLeave( %this, %object )
{
    if ($filesTransferred < 10)
     {
       say(0,0, "<F5>Data Transfer Aborted.", "dlink_abort.wav");
       $filesTransferred = 0;
       $linkActive = false;
     }
}

function datalink::trigger::onContact( %this, %object )
{
    if ($filesTransferred == 0)
     {
       say (0,0, "<F5>Transferring Data...");
     }
    $filesTransferred++;
    if ($filesTransferred == 10)
     {
       $objective2 = true;
       say (0,0, "<F5>Data Transfer complete.", "dlink_complete.wav");
       schedule( "say( 0, 0, \"GEN_OC01.wav\" );", 2 );
       schedule ( "bigTrouble();", 5); 
     }
}

//-----------------------------------------------------------------------------
function pickPlayer ()
{

// 100 so we can be assured of getting a live player
   for (%p = 0; %p < 100; %p++)
     {
      %player = playerManager::getPlayerNum( randomInt( 0, playerManager::getPlayerCount() - 1 ) );

      %playerVeh = playerManager::playerNumToVehicleId( %player);

      if (( %playerVeh != "" ) &&
          (isGroupDestroyed (%playerVeh) == false))
       {
         return %playerVeh;
       }
     }
  return 0;
}

//-----------------------------------------------------------------------------
function onLeaveNavTransport ()
{
   createVulture();
   createGuards1();
   createGuards2();

say (0,0, "TAC-COM: Kodiak Patrol, Orbital Recon is reporting movement within the destroyed base.  There could be survivors of the attack; make sure they get back to the transport safely.");
$actionStarted = true;
MPcheckBoundary( enter, getObjectID ($navAlpha) , 100, onArriveNavAlpha, 1);

}

//-----------------------------------------------------------------------------
function onLeaveNavTransportWarning ()
{
   say (0,0, "<f5>You are leaving the drop zone. By doing so you will start the mission.");
}

//-----------------------------------------------------------------------------
function setEnemyNavPoint( %this )
{
  setNavMarker( $navAlpha, true, %this );
}

function createDrones()
{
   %x = 2388;
   %y = 1188;

   %name = "Repair";
   %herc = newObject( %name, Tank, 71);
   setTeam ( %herc, *IDSTR_TEAM_YELLOW );

   addToSet( $drones, %herc );
   placeObject ( %herc, %x, %y );

   $truck = %herc;

   // starfield, just for appearances

   %x = 2288;
   %y = 1158;

   %name = "Starfield";
   %herc = newObject( %name, Tank, 73);
   setTeam ( %herc, *IDSTR_TEAM_YELLOW );

   addToSet( $drones, %herc );
   placeObject ( %herc, %x, %y, 90 );

}       


function createFlyers()
{
   %x = 2368;
   %y = 1088;

   %name = "conveyor";
   %herc = newObject( %name, Flyer, 132 );
   setTeam( %herc, *IDSTR_TEAM_YELLOW);
   addToSet ($Flyers, %herc);
   placeObject(%herc, %x, %y);
   $Transport = %herc;

   %name = "cargo";
   %herc = newObject( %name, Flyer, 18 );
   setTeam( %herc, *IDSTR_TEAM_RED);
   addToSet ($Flyers, %herc);
   placeObject(%herc, -704, 3072);
   $cargo = %herc;

   order( $Flyers, shutdown, true );
}

function createRebel()
{
   %name = "Rebel";
   %herc = newObject( %name, Herc, 30 );
   setTeam( %herc, *IDSTR_TEAM_PURPLE );
   addToSet ($Rebs, %herc);
   placeObject(%herc, 192, 880);
   damageObject( %herc, 7000 );
   order( %herc, shutdown, true );
   
}

function createVulture()
{
   %r = randomInt(1,2);
   if (%r = 1)
    {
      %y = 100;
    }
   else 
    {
      %y = 1500;
    }
   %howMany = countLivePlayers ();
   if (%howMany < 3)
    {
      %veh = 52;
    }
   else
    {
      %veh = 50;
    }
   %name = "Vulture";
   %herc = newObject( %name, Herc, %veh );
   setTeam( %herc, *IDSTR_TEAM_RED );
   setPilotID (%herc, 30);
   addToSet ($Vulture, %herc);
   placeObject(%herc, 750, %y);
   order (%herc, guard, $VulturePath);
   
}

function createGuards1()
{
  %howMany = countLivePlayers ();

  if ( %howMany > 3 ) %howMany = 3;

  %x = -854;
  %y = 3072;

  for ( %i = 0; %i < %howMany ; %i++ )
   {

//if ( %i > 10 ) break;

     %name = "Pirate"@ %i;
     %r = randomInt (1,3);

   if (%r == 1)
    {
     %herc = newObject( %name, Tank, 51);
    }
   else if (%r == 2)
    {
     %herc = newObject( %name, Herc, 52);
    }
   else if (%r == 3)
    {
     %herc = newObject( %name, Herc, 50);
    }

    setTeam (%herc, *IDSTR_TEAM_RED);
    %pilotID = 28;
    setPilotID (%herc, %pilotID);

    addToSet( $Guards1, %herc ); 

    placeObject(%herc, %x, %y, 180);

    %x = %x + 10;

   } // end for loop


}
//-----------------------------------------------------------------------------
function MPcheckBoundary( %dir, %obj2, %distance, %callback, %time )
{
// This is a modification of the campaign function "CheckBoundary"
//
// %dir  - enter or leave
// %obj2 - any object you want the players distance compared to
//         must be an ID (use getObjectid) and not a string ("MissionGroup/RedHerc/h1")
// %distance - if entering, they'd be within this range to run the function
//             if leaving, they'd be outside this range to run the function
// %callback - name of the function to run
// %time - when to reschedule the next check

  %jobRun = false;

   %playerCount = playerManager::getPlayerCount();

   for(%i=0; %i < %playerCount ; %i++)
     {
     %player = playerManager::getPlayerNum( %i );

     %obj1= playerManager::playerNumToVehicleId( %player);

   %var = getDistance( %obj1, %obj2 );

    if (%var != "0")
     {
     if( %dir == "enter" || %dir == "Enter" )
       {
        if( %var <= %distance )
          {
          if ( %jobRun == false )
            {
              %func = %callback @ "(" @ %obj1 @ ");";
              schedule( %func, 0 );
              %jobRun = true;
            }
          }
       }
    else if( %dir == "leave" || %dir == "Leave" )
      {
       if( %var >= %distance )
         {
          if ( %jobRun == false )
            {
              %func = %callback @ "();";
              schedule( %func, 0 );
              %jobRun = true;
            }
         }
      }
    }
  } // end for loop

  if  (%jobRun != true )
   {
   schedule( "MPcheckBoundary( "
             @ %dir @ ", "
             @ %obj2 @ ", "
             @ %distance @ ", "
             @ %callback @ ", "
             @ %time @ ");",
             %time );

   }

}


//-----------------------------------------------------------------------------
function pickPlayer ()
{

// 100 so we can be assured of getting a live player
   for (%p = 0; %p < 100; %p++)
     {
      %player = playerManager::getPlayerNum( randomInt( 0, playerManager::getPlayerCount() - 1 ) );

      %playerVeh = playerManager::playerNumToVehicleId( %player);

      if (( %playerVeh != "" ) &&
          (isGroupDestroyed (%playerVeh) == False))
       {
         return %playerVeh;
       }
     }
  return 0;
}

//-----------------------------------------------------------------------------
function countLivePlayers ()
{

  %count = 0;

   %playerCount = playerManager::getPlayerCount();

   for (%p = 0; %p < %playerCount; %p++)
     {
      %player = playerManager::getPlayerNum( %p );

      %playerVeh = playerManager::playerNumToVehicleId( %player);

      if (( %playerVeh != "" ) &&
          (isGroupDestroyed (%playerVeh) == False))
       {
         %count++;
       }
     }
  return %count;

}

//-----------------------------------------------------------------------------
function placeObject (%object, %x, %y, %rot)
{

  if ( %rot == "" ) %rot = 0;

  %z = getTerrainHeight(%x, %y);
  setPosition (%object, %x, %y, %z + 2, %rot);

}


//-----------------------------------------------------------------------------
function checkForPlayersDead()
{
  %allDead = true;

   %playerCount = playerManager::getPlayerCount();

   for (%p = 0; %p < %playerCount; %p++)
     {
      %player = playerManager::getPlayerNum( %p );

      %playerVeh = playerManager::playerNumToVehicleId( %player);

      if (( %playerVeh != "" ) &&
          (isGroupDestroyed (%playerVeh) == False))
       {

         %allDead = False;
       }
     }

  if ( %allDead == true ) schedule ("missionFailed();", 3);

}

//-----------------------------------------------------------------------------
function missionFailed()
{
  flushConsoleScheduler();
  messageBox(0, "Mission Failed" );

  deleteObject("MissionGroup");
  deleteObject("MissionCleanup");
  deleteVariables($objective1);
  deleteVariables($objective2);
  deleteVariables($linkActive);
  deleteVariables($filesTransferred);
  deleteVariables($guardsDead);
  deleteVariables($turretsDead);
  deleteVariables($complaint);
  deleteVariables($spares);
  deleteVariables($navAlpha);
  deleteVariables($navBravo);
  deleteVariables($navCharlie);
  deleteVariables($navTransport);
  deleteVariables($VulturePath);
  deleteVariables($drones);
  deleteVariables($Flyers);
  deleteVariables($Rebs);
  deleteVariables($Vulture);
  deleteVariables($Guards1);
  deleteVariables($Guards2);
  deleteVariables($Pirates);
  deleteVariables($turrets);
  deleteVariables($Fusion);
  deleteVariables($CommCenter);
  deleteVariables($truck);
  deleteVariables($transport);

  // $MissionCycling::Stage0 = "c_rescue";
  //$server::Mission = $MissionCycling::Stage0;
  missionEndConditionMet();
  // schedule("missionEndConditionMet();", 10);
}

//-----------------------------------------------------------------------------
function winCondition()
{
  flushConsoleScheduler();
  %howmany = 0;

  %text = "\nJovian Dark Knights Supply Base secured: ";
  if ( $objective1 == true )
    {
     %howmany++;
     %text = %text @ "Successful";
    }
   else
    {
     %text = %text @ "Failed";
    }
  %text = %text @ "\nBase Files downloaded: ";
  if ( $objective2 == true )
    {
     %howmany++;
     %text = %text @ "Successful";
    }
   else
    {
     %text = %text @ "Failed";
    }

  if ( %howmany == 2 ) %text = %text @ "\nExcellent work team.";

  messageBox(0, "Mission Completed, " @ %howmany @ " of 2 objectives completed. "@ %text );

  deleteObject("MissionGroup");
  deleteObject("MissionCleanup");
  deleteVariables($objective1);
  deleteVariables($objective2);
  deleteVariables($linkActive);
  deleteVariables($filesTransferred);
  deleteVariables($guardsDead);
  deleteVariables($turretsDead);
  deleteVariables($complaint);
  deleteVariables($spares);
  deleteVariables($navAlpha);
  deleteVariables($navBravo);
  deleteVariables($navCharlie);
  deleteVariables($navTransport);
  deleteVariables($VulturePath);
  deleteVariables($drones);
  deleteVariables($Flyers);
  deleteVariables($Rebs);
  deleteVariables($Vulture);
  deleteVariables($Guards1);
  deleteVariables($Guards2);
  deleteVariables($Pirates);
  deleteVariables($turrets);
  deleteVariables($Fusion);
  deleteVariables($CommCenter);
  deleteVariables($truck);
  deleteVariables($transport);

  // $MissionCycling::Stage0 = "c_rescue";
  // $server::Mission = $MissionCycling::Stage0;
  missionEndConditionMet();
  // schedule("missionEndConditionMet();", 10);
}

//-----------------------------------------------------------------------------



function createGuards2()
{

  %howMany = countLivePlayers ();

  if ( %howMany > 1 ) %howMany = %howMany - 1;

  %x = -554;
  %y = 3072;

  for ( %i = 0; %i < %howMany ; %i++ )
   {

//if ( %i > 10 ) break;

     %name = "Pirate"@ %i;
     %r = randomInt (1, 3);

   if (%r == 1)
    {
     %herc = newObject( %name, Tank, 51);
    }
   if (%r == 2)
    {
     %herc = newObject( %name, Herc, 52);
    }
   if (%r == 3)
    {
     %herc = newObject( %name, Herc, 50);
    }

    setTeam (%herc, *IDSTR_TEAM_RED);
    %pilotID = 28;
    setPilotID (%herc, %pilotID);

    addToSet( $Guards2, %herc ); 

    placeObject(%herc, %x, %y, 180);

    %x = %x - 10;

    }    
  
    
}

function createPirates()
{
  %howMany = countLivePlayers ();
  
  if ( %howMany > 1 ) %howMany = %howMany - 1;

  %x = -1000;
  %y = 650;

  for ( %i = 0; %i < %howMany ; %i++ )
    {

//if ( %i > 10 ) break;

     %name = "Pirate"@ %i;
      %herc = NewObject( %name, Herc, 52);

     setTeam (%herc, *IDSTR_TEAM_RED);
     %pilotID = randomInt ( $minAIPilotID, $maxAIPilotID );
     setPilotId (%herc, %pilotID);

     addToSet( $Pirates, %herc ); 

     placeObject(%herc, %x, %y);

     %x = %x + 10;

    } // end for loop
    
   
}

//-----------------------------------------------------------------------------
function checkRedropSquad()
{
   if ((isGroupDestroyed($Guards1) == true) && ( $attackStarted == true))
    {
      if (isGroupdDestroyed($Guards2) == false) 
       {
         if ($complaint == false)
          {
            say (0,0, "JDK BASE COMMAND: Where the Hunter are those raiders?  Our boys are getting toasted out there!");
            $complaint = true;
          }
       }
      if (isGroupDestroyed($Guards2) == true)
       {
         $guardsDead = true;
       }
    }
   if (($guardsDead == true) && ($turretsDead == true))
    {
      if ($objective1 == false)
       {
          say (0,0, "TAC-COM: Good work, Kodiak!  We're dispatching a Police transport to arrest the base personnel.  Now find the base computer network and download all the files.  We need the evidence before they can wipe it.");
          $objective1 = true;
          schedule( "say( 0, 0, \"GEN_OC01.wav\" );", 2 );
       }
    }
}

//-----------------------------------------------------------------------------
function onArriveNavBravo()
{
   setNavMarkerON( $navCharlie );
   MPcheckBoundary( enter, getObjectID ($navCharlie) , 1100, onArriveNavCharlie, 1 );
}

//-----------------------------------------------------------------------------
function setNavMarkerON ( %navMarker )
{
   %playerCount = playerManager::getPlayerCount();

   for (%p = 0; %p < %playerCount; %p++)
     {
      %player = playerManager::getPlayerNum( %p );

      %playerVeh = playerManager::playerNumToVehicleId( %player);

      setNavMarker( %navMarker, true, %playerVeh  );
     }
}

function onArriveNavAlpha()
{

     order ( $Rebs, shutdown, false );
     say (0,0, "REBEL: *cough* Never thought I'd be glad to see a bunch of Lice...  Those pirates scorched us bad.  They took everything we had, killed everybody... We had kids here for Hunter's sake!... *cough*");
     schedule( "say(0,0, \"REBEL: My life-support's almost zero.  I can't last much longer...  You'd better watch it; those goons had a lot of firepower behind them... \");", 8);
     schedule( "order($Rebs, guard, $Transport);", 14);
     schedule( "setNavMarkerON( $navBravo );", 14);
     MPcheckBoundary( enter, getObjectID ($navBravo) , 150, onArriveNavBravo, 1 );
     createPirates();
     %target = pickPlayer();
     schedule ( "order($Pirates, attack, " @ %target @ ");", 35);
     
}

//-----------------------------------------------------------------------------
function onArriveNavCharlie()
{
   %target1 = pickPlayer();
   %target2 = pickPlayer();

   say (0,0, "JDK GUARD: Base Command this is Watchdog One.  We have Imp forces converging on our position.  We're moving to engage.  Jam their comm system to prevent them betraying our location!");
   schedule( "say(0,0, \"UNIDENTIFIED: Roj that, Watchdog.  We're scrambling all raiders in the sector.  The Imps won't leave the area alive!\");", 8);
   order ($Guards1, attack, %target1);
   schedule ( "order($Guards2, attack, " @ %target2 @ ");", 10);
   $attackStarted = true;
   checkTurrets();
}

function checkTurrets()
{
    if (isGroupDestroyed($turrets) == true)
     {
       $turretsDead = true;
       if (($guardsDead == true) && ($objective1 == false))
        {
          say (0,0, "TAC-COM: Good work, Kodiak!  We're dispatching a Police transport to arrest the base personnel.  Now find the base computer network and download all the files.  We need the evidence before they can wipe it.");
          $objective1 = true;
          schedule( "say( 0, 0, \"GEN_OC01.wav\" );", 2 );
        }
       else
        {
          schedule ( "checkTurrets();", 5);
        }
     } 
    else 
     {
       schedule ( "checkTurrets();", 5);
     }
}

function bigTrouble()
{
   
   say (0,0, "<f5>WARNING: Self-Detonation program in effect.  Base Fusion Generator is approaching overload.  Nuclear Detonation imminent."); 
   setHudTimer( 60, -1, "Detonation in:", 1);
   schedule ( "damageArea( $Fusion, 0, 0, 0, 750, 1500000);", 60);

   schedule ( "wrapUp();", 65 );
   
}   

function wrapUp()
{
   say (0,0, "TAC-COM: Kodiak, is everyone alright?...  I can't believe it.  They blew up their own base rather than face arrest.  What kind of monsters are we dealing with?");
   schedule( "say(0,0, \"TAC-COM: At least we got the files... maybe this will shed some light on who's suppling the pirates.  And the loss of that base ought to put an end to the threat they posed.  Get back to the transport; we'll have medics waiting when you reach base.\");", 8);
   schedule ( "winCondition();", 18 );
}

function redropTruck()
{
   if ($spares > 0)
    {
      say (0,0, "<f5>Repair truck destroyed.  A spare truck is departing from the drop zone.");
      %x = 2388;
      %y = 1188;

      %herc = newObject( "Repair", Tank, 71);
      setTeam ( %herc, *IDSTR_TEAM_YELLOW );

      addToSet( $drones, %herc );
      placeObject ( %herc, %x, %y, 180 );
      $truck = %herc;  
      $spares--;

      %target = pickPlayer();
      order ($truck, guard, %target);

    }
}