// FILENAME:	CTF_Fortresses.cs
//
// AUTHOR:  	/ {HM} Sabre -*-
//------------------------------------------------------------------------------

$missionName = "CTF_Fortresses";

$maxFlagCount  = 5;          // number of flags required by a team to end the game
$flagValue     = 15;         // points you get for capturing
$carrierValue  = 3;          // points you get for killing carrier
$killPoints    = 1;          // points gained per kill
$deathPoints   = 1;          // points lost per death
$flagTime = 150;             // time allowed for carrier to capture flag

exec("multiplayerStdLib.cs");
exec("CTFstdLib.cs");

function setDefaultMissionOptions()
{
	$server::TeamPlay = false;
	$server::AllowDeathmatch = false;
	$server::AllowTeamPlay = true;	

   // what can the client choose for a team
	$server::AllowTeamRed = false;
	$server::AllowTeamBlue = true;
	$server::AllowTeamYellow = false;
	$server::AllowTeamPurple = true;

   // what can the server admin choose for available teams
   $server::disableTeamRed = true;
   $server::disableTeamBlue = false;
   $server::disableTeamYellow = true;
   $server::disableTeamPurple = false;
}

function onMissionStart()
{
	marsSounds();
}

function player::onAdd(%this)
{
   say(%this, 0, "Welcome to CTF_Fortresses!  I expect a clean game, with no whining about the rules, so read them before spawning.  This map was created by / {HM} Sabre -*-.");
 
}

function onMissionLoad()
{
   cdAudioCycle("Purge", "Terror", "Watching"); 
   setGameInfo("<F2>GAME TYPE:<F0>  CApture The Flag\n\n<F2>MISSION:<F0>  Fortresses\n\nWelcome to CTF.  You and your team will be pitted against the opposing team.  Each team has a base, which is where they spawn.  Steal the opposing team's flag and return it tou your own to score points for your team.  <F5>Teamwork is a must!<F0>  Sucessfully invading the enemy base will allow you to kill the enemy as they spawn.  Beware, the other team may attemt this on you.\n\nSpawnkilling IS allowed AND encouraged.\n\nAutoheal is OFF.\n\n<F2>CREATOR:<F0> / {HM} Sabre -*-");
}

// Water Tower splash functionality
function structure::onDestroyed(%this, %attackerId){
	// Which water tower was destroyed?
	if(%this == getObjectId("MissionGroup\\BlueBase\\WaterTower1")){
		setShapeVisibility(getObjectId("MissionGroup\\BlueBase\\Splash1"), true);
		playAnimSequence(getObjectId("MissionGroup\\BlueBase\\Splash1"), 0, true);
	}
	else if(%this == getObjectId("MissionGroup\\BlueBase\\WaterTower2")){
		setShapeVisibility(getObjectId("MissionGroup\\BlueBase\\Splash2"), true);
		playAnimSequence(getObjectId("MissionGroup\\BlueBase\\Splash2"), 0, true);
	}
	else if(%this == getObjectId("MissionGroup\\BlueBase\\WaterTower3")){
		setShapeVisibility(getObjectId("MissionGroup\\BlueBase\\Splash3"), true);
		playAnimSequence(getObjectId("MissionGroup\\BlueBase\\Splash3"), 0, true);
	}
}
